package graphics2.listener;


import java.awt.Toolkit;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;

import graphics2.panel.client.*;
/**
 * 
 * @author mladoue
 * @version 0.1, Jun 14, 2003
 */
public class MyTreeSelectionListener implements TreeSelectionListener {

	protected JTree tree;
	private Toolkit toolkit = Toolkit.getDefaultToolkit();

	ClientPanel cp;
	public MyTreeSelectionListener(JTree tree, ClientPanel cp) {
		this.tree = tree;
		this.cp=cp;
	}

	public void valueChanged(TreeSelectionEvent e) {
	
			//		Get paths of all selected nodes
			TreePath[] paths = tree.getSelectionPaths();
			if( paths != null) {
			DefaultMutableTreeNode[] nodesList = new DefaultMutableTreeNode[paths.length];
			DefaultMutableTreeNode currentNode;
		
			for (int i=0; i< nodesList.length; i++) {
				currentNode = (DefaultMutableTreeNode) (paths[i].getLastPathComponent());		

			if ( currentNode == null ) { 
				toolkit.beep();
				return;
			 }
			 
			 String nodeInfo = currentNode.getUserObject().toString();

			 if( !currentNode.isLeaf() ) {
			 		 // Only display the scenario info if it's not a leaf (ie, not a model or codec).
				cp.displayScenario(nodeInfo);			 	
			 }
			}
			}
	}

}
