package graphics2.listener;


import graphics2.GestionTest;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import multimedia.generation.ScenarioFileAnalyzer;

import utils.MyCustonDialog;
import utils.ScenarioFileFilter;

/**
 * This run a FileChooser: you select a scenario file
 * 	- it pops up a dialog window to select test parameters
 * 	- it runs ScenarioFileAnalyser which says if it's good or not
 *  
 * @author mladoue
 * @version 0.1, Jun 19, 2003
 */

public class TestScenarioFileActionListener implements ActionListener {

	private GestionTest gestionTest;
	private int IPTime;
	private int percentage;
	private JFileChooser fc = new JFileChooser();
	
	public TestScenarioFileActionListener( GestionTest gestionTest) {
		this.gestionTest = gestionTest;
	}


	/**
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		fc.addChoosableFileFilter( new ScenarioFileFilter() );
					int returnVal = fc.showOpenDialog( gestionTest );
	
					if (returnVal == JFileChooser.APPROVE_OPTION) {
						File file = fc.getSelectedFile();
						try {
							if (file != null) {
								askTestParameters();
								ScenarioFileAnalyzer.isValidScenario(file.getName(),IPTime,percentage,true);
							}
						}
						
						catch( FileNotFoundException fnfe) {
							JOptionPane.showMessageDialog( gestionTest,"This file does not exist","Test file error",JOptionPane.ERROR_MESSAGE);
						}
						catch(SecurityException se) {
							JOptionPane.showMessageDialog( gestionTest,"Permission problem","Test file error",JOptionPane.ERROR_MESSAGE);
						}
						
					}
	}

	protected boolean askTestParameters(){
		   Vector v1=new Vector();
		   v1.add("Maximum inter-packet time(in ms): ");
		   v1.add("Accepted percentage error(in %): ");

		   Vector v2 = new Vector();
		   v2.add("10");
		   v2.add("5");

		  MyCustonDialog f = new MyCustonDialog( gestionTest, "Test parameters",v1,v2);
		  
		  Vector v3 = f.getValeursChamps();
		   String s;
		   try {
			   s=(String)(v3.get(0));
			   IPTime =  Integer.parseInt(s);
			   s=(String)(v3.get(1));
			  percentage =  Integer.parseInt(s);
		   }
		   catch (Exception e) { e.printStackTrace(); }
		   
		   return f.getEtat();
	   }


}
