package graphics2.listener;

/**
 * @author mladoue
 *
 */
import graphics2.GestionTest;

import java.awt.event.*;
import java.util.Vector;

import traffic.generation.*;
import utils.*;

public class TrafficGeneratorActionListener implements ActionListener {

protected GestionTest gt;
protected String scenarioFileName;
protected int rmiPort = 1099; //default value
protected TrafficGenerationAction tga;

public TrafficGeneratorActionListener(GestionTest gt) {
	this.gt = gt;	
}



public void actionPerformed(ActionEvent e) {
	// First, check that evithing is ok for a generation
	// ie, configuration and host XML file are ok.
	
	// The simplest, check that there is a hostconf file.
	// look at ExperimentPanel and write the config.
	if (gt.getExperimentPanel().hasMachineDescription()){
		// Save the configuration file.
		String filename="/tmp/hostconf"+System.currentTimeMillis()+".xml";
		if (gt.getExperimentPanel().saveFile(filename)) {
			// Check that all configuration files are existing...
			if (gt.getExperimentPanel().allFileExist()) {
				// on bloque les valeurs choisies
				gt.freezeAll(true);
	
				if( askRmiPort() == true ) {
					tga = new TrafficGenerationAction(gt, rmiPort);
					tga.selectHostInfoFile(filename);
					tga.start();
				}
			}
			else {
				MessageManager.errorMessage( "At least one scenario file is unknows.\nPlease, check its Path or its name", true);		
			}
		}
		else {
			MessageManager.errorMessage( "Error writing host information file.\nPlease, check the Experiment Panel", true);		
		}
	}
	else {
		MessageManager.errorMessage( "Cannot start a traffic generation without a machine configuration.\n" +
			"Please load an host information file or build on using Experiment configuration Panel ", true);		
	}
}


	/**
	 * Pop up a dialog windows to ask rmi port
	 * @return
	 * boolean
	 */
	protected boolean askRmiPort(){
		   Vector v1= new Vector();
		   v1.add("Rmi port: ");

		   Vector v2 = new Vector();
		   v2.add("1099");

		  MyCustonDialog f = new MyCustonDialog( gt, "RMI parameters",v1,v2);
		  
		  Vector v3 = f.getValeursChamps();
		  String s;
		  try {
			   s=(String)(v3.get(0));
			   rmiPort =  Integer.parseInt(s);
		   }
		   catch (Exception e) { e.printStackTrace(); }
		   
		   return f.getEtat();
	   }




}
