package graphics2.listener.generator;

import java.io.IOException;

import org.w3c.dom.Element;
import multimedia.VideoDefinition;
import multimedia.generation.*;
import multimedia.model.*;
import graphics2.GestionTest;

/**
 * @author mladoue
 * @version 0.1
 */

public class MGInfComplexAggregatedFlowGeneratorConstructor extends AggregatedModelGeneratorConstructor {
	//En ce qui concerne ce modele + specifiquement
	protected  MGInfModel[] models;
	protected int[] weights;
	protected short[] units;
	protected int nbDifferentFlow;
	protected int flowsNumber;
	//	En ce qui concerne le generateur
	protected VideoDefinition[] vds;
	protected String fileName;
	protected short unit;


	public MGInfComplexAggregatedFlowGeneratorConstructor( GestionTest gt , Element nlFlow) {
		super(gt, nlFlow);
		fileName = sfp.createScenarioFileName(cp);
		unit = 0;
		
//		System.out.println("nb Different Flow:  " + nbDifferentFlow );	// DEBUG
//		System.out.println("Model : " + models[0].getName());	 // DEBUG
//		System.out.println("duration " + duration);	 // DEBUG
//		System.out.println("Unit " + units[0]);	 // DEBUG
//		System.out.println("Flows number: " + flowsNumber);	 // DEBUG
//		System.out.println("FileName: " + fileName);	 // DEBUG
	}

	protected void setModelParameters(Element elt) {
		org.w3c.dom.NodeList lnodes = elt.getElementsByTagName("submodel");
		nbDifferentFlow =lnodes.getLength();
		flowsNumber =0;

			// Allocate the arrays
		vds = new VideoDefinition[nbDifferentFlow];
		weights = new int[nbDifferentFlow];
		units = new short[nbDifferentFlow];
		models = new MGInfModel[nbDifferentFlow];

			// and add the different onOff model of this aggregated model...
		for(int i=0; i <nbDifferentFlow; i++) {
			String name =  ( (Element)lnodes.item(i)).getAttribute("video"); 
			vds[i] = utils.SpecificObjectCreation.createVideoExample(VideoDefinition.getCompleteName(name));
			weights[i]= Integer.valueOf(((Element)lnodes.item(i)).getAttribute("source")).intValue();
			flowsNumber += weights[i];
			units[i] = (short)0; // fixed to BYTES
			models[i] = vds[i].getModel();
			// Ok, but the duration can be changed from the predefined value of VideoExample...
		}
	}
	
	/**
	 * constructModelGenerator : 
	 * 		- cree le model
	 * 		- cree le model generator
	 * @throws IOException
	 */
	public void constructModelGenerator() throws IOException {
		//TODO: Modifier la construction des MGInfComplexAggregatedFlowGeneration car mafm n'est meme pas passe en parametre...
		//MGInfAggregatedFlowModel mafm = new MGInfAggregatedFlowModel(models, weights,"MGInfComplexAggregatedFlow");
		//MGInfComplexAggregatedFlowGeneration mginfcomplexAggregatedGenerator = new MGInfComplexAggregatedFlowGeneration(mafm, units, duration, fileName, true);

		multimedia.model.MGInfAggregatedFlowModel mafm = new multimedia.model.MGInfAggregatedFlowModel();
				mafm.setParamsCount(2);
				mafm.setName("MGInfComplexAggregatedFlow");
				mafm.setFlowTypeNumber(nbDifferentFlow );
				mafm.setModels( models );
				mafm.setWeights( weights);
				mafm.setSourceNumber();
		
				MGInfComplexAggregatedFlowGeneration mginfcomplexAggregatedGenerator = new MGInfComplexAggregatedFlowGeneration();

				//mginfcomplexAggregatedGenerator.flowsNumber = 3;

				mginfcomplexAggregatedGenerator.setModel( mafm );
				mginfcomplexAggregatedGenerator.setFlowTypeNumber(nbDifferentFlow );
				mginfcomplexAggregatedGenerator.setParameters(vds, weights, (short)0, fileName, false);

	System.out.println("====>>>>>>> "+duration);
		genericAggModel = mafm;
		genericGen = mginfcomplexAggregatedGenerator;
	}
}
