package graphics2.listener.generator;

import java.io.IOException;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


import multimedia.generation.*;
import multimedia.model.*;
import graphics2.*;
import multimedia.codec.*;


/**
 * MMPP2GeneratorConstructor
 * 
 * @author mladoue
 * @version 0.1, 18/11/02 
 */
public class MMPP2GeneratorConstructor extends SimpleModelGeneratorConstructor {
	
		// MMPP2 Model parameters
	protected int startState;
	protected double alpha, beta, lambda1, lambda2;
	private String codecName;
	private double IPTime;
	private int psize;
	
	public MMPP2GeneratorConstructor(GestionTest gt, Element nFlow) {
		super(gt, nFlow);
	}
	
	public void setModelParameters(Element model) {
		System.out.println("Model node: " + model.toString() ); //DEBUG
		
		NodeList nl = model.getChildNodes();
		for (int i=0; i < nl.getLength(); i++) {
			String name =  nl.item(i).getNodeName();
			if (name.equals("sstate")) {
				startState = (Integer.valueOf(((Element) nl.item(i)).getAttribute("value")).intValue() );
			}
			else if(name.equals("alpha")) {				
				alpha = Double.valueOf(((Element) nl.item(i)).getAttribute("value")).doubleValue();
			}												
			else if(name.equals("beta")) {
				beta = Double.valueOf(((Element) nl.item(i)).getAttribute("value")).doubleValue();		
			}
			else if(name.equals("lambda1")) {
				lambda1 = Double.valueOf(((Element) nl.item(i)).getAttribute("value")).doubleValue();	
			}
			else if (name.equals("lambda2")) {
				lambda2 = Double.valueOf(((Element) nl.item(i)).getAttribute("value")).doubleValue();	
			}
			else {
				System.out.println("Error: unknown parameters!");
			}
		}
//		System.out.println("start state: " + startState);	 // DEBUG
//		System.out.println("parameters: " + alpha + " " + beta + " " + lambda1 + "  " + lambda2 );	 // DEBUG
	}
	
	/**
	 * constructModelGenerator : 
	 * 		- cree le model
	 * 		- cree le model generator
	 * @throws IOException
	 */
	
 	public void constructModelGenerator() throws IOException {
 		MMPP2Model mmpp2m = new MMPP2Model(startState, alpha, beta, lambda1,lambda2, (AudioCodec)codec);
 		MMPP2Generation mmpp2g = new MMPP2Generation(mmpp2m, duration, 1, fileName, true); //srcNumber unused
		genericAggModel=mmpp2m;
		genericGen=mmpp2g;
 	}
}
