package graphics2.listener.generator;

/**
 * OnOffGeneratorConstructor
 * 
 *@author mladoue
 *@version 0.1, 17/01/03
 */

import java.io.IOException;

import org.w3c.dom.*;

import multimedia.model.*;
import multimedia.codec.AudioCodec;
import multimedia.generation.*;
import graphics2.*;
import statistic.distribution.*;
import utils.ObjectConstructor;


public class OnOffGeneratorConstructor extends SimpleModelGeneratorConstructor {
		//	Model parameters
	protected int startState;
	protected GenericDistribution law1, law2;
	private String law1Name, law2Name;
	private double[] law1Params, law2Params;
		
	/**
	 * @see graphics.listener.ModelGeneratorConstructor#ModelGeneratorConstructor(GestionTest,Element)
	 */
	public OnOffGeneratorConstructor(GestionTest gt, Element nFlow) {
		super(gt, nFlow);
	}

	public void setModelParameters(Element model) {
		//System.out.println("Model node: " + model.toString()); //DEBUG
		NodeList nl=model.getChildNodes();	
		for (int i=0; i < nl.getLength(); i++) {
			String name =  nl.item(i).getNodeName();
			if (name.equals("sstate"))
				startState = (Integer.valueOf( ((org.w3c.dom.Element) nl.item(i)).getAttribute("value")).intValue() );
			else if(name.equals("distribution1")) {
				law1Name =((Element)nl.item(i)).getAttribute("name");
					// initialisation de law1Params
				if (((org.w3c.dom.Element) nl.item(i)).getAttribute("param2").equals("")) {
					law1Params = new double[1];
				}
				else {
					law1Params = new double[2];
					law1Params[1]= Double.valueOf(((Element) nl.item(i)).getAttribute("param2")).doubleValue();
				}
				law1Params[0]=Double.valueOf(((Element) nl.item(i)).getAttribute("param1")).doubleValue();
				System.out.println("Distribution description :" + law1Name + " " + law1Params[0]); //DEBUG
				law1 = ObjectConstructor.createDistribution(law1Name, law1Params);
			}
			else if(name.equals("distribution2")) {
				law2Name = ((org.w3c.dom.Element) nl.item(i)).getAttribute("name");
				if (((org.w3c.dom.Element) nl.item(i)).getAttribute("param2").equals("")) {
					law2Params = new double[1];
				}
				else {
					law2Params = new double[2];
					law2Params[1]=Double.valueOf(((Element) nl.item(i)).getAttribute("param2")).doubleValue();
				}
				law2Params[0]=Double.valueOf(((org.w3c.dom.Element) nl.item(i)).getAttribute("param1")).doubleValue();
				law2 = ObjectConstructor.createDistribution( law2Name, law2Params);
				System.out.println("Distribution description :" + law2Name + " " + law2Params[0]); //DEBUG
			}
		}
	}
	
	
	/**
	 * constructModelGenerator : 
	 * 		- cree le model
	 * 		- cree le model generator
	 * @throws IOException
	 */
 	public void constructModelGenerator() throws IOException {
 		OnOffModel oom = new OnOffModel(startState, law1, law2, (AudioCodec)codec);
		OnOffGeneration oog = new OnOffGeneration(oom, duration, 1, fileName, true); // src number unused
		genericAggModel = oom;
		genericGen = oog;
 	}
}
