package graphics2.listener.generator;

import java.io.IOException;
import org.w3c.dom.Element;
import multimedia.generation.*;
import multimedia.model.*;
import multimedia.codec.*;
import statistic.distribution.*;
import graphics2.GestionTest;

/**
 * @author mladoue
 * @version 0.1, 26/05/03
 */


public class OnOffHeterogeneousAggregatedFlowGeneratorConstructor extends AggregatedModelGeneratorConstructor {

	protected OnOffHeterogeneousAggregatedFlowModel oohafm;
	protected OnOffHeterogeneousAggregatedFlowGeneration oohafg;

	//	En ce qui concerne ce modele + specifiquement
	protected OnOffModel[] models;
	protected int[] sourceNumber;
	protected int nbDifferentFlow;
	//	En ce qui concerne le generateur
	protected String fileName =""; 


	public OnOffHeterogeneousAggregatedFlowGeneratorConstructor( GestionTest gt , Element nlFlow) {
		super(gt, nlFlow);
		//fileName = "test"; 
		fileName = sfp.createScenarioFileName(cp);

//		System.out.println("nb Different Flow:  " + nbDifferentFlow );	// DEBUG
//		System.out.println("Model : " + models[0].getName());	 // DEBUG
//		System.out.println("duration " + duration);	 // DEBUG
//		System.out.println("FileName: " + fileName);	 // DEBUG
	}
	
	protected void setModelParameters(Element elt) {
		org.w3c.dom.NodeList lnodes = elt.getElementsByTagName("submodel");
		
		nbDifferentFlow =0;
		// First, count the number of sub-model.
		for(int i=0; i <lnodes.getLength(); i++) {
			if ( ((org.w3c.dom.Element)lnodes.item(i)).getAttribute("name").equals("OnOff")) {
				nbDifferentFlow++;
			}
		}
			// Allocate the arrays
		models = new OnOffModel[nbDifferentFlow];
		sourceNumber = new int[nbDifferentFlow];

			// and add the different onOff model of this aggregated model...
		for(int i=0; i <lnodes.getLength(); i++) {
			if ( ((org.w3c.dom.Element)lnodes.item(i)).getAttribute("name").equals("OnOff")) {
					// Rebuild the Flow info
				int flowNo = Integer.parseInt (((org.w3c.dom.Element)lnodes.item(i)).getAttribute("number"));
				sourceNumber[flowNo-1]=Integer.parseInt (((org.w3c.dom.Element)lnodes.item(i)).getAttribute("nbsources"));

				org.w3c.dom.NodeList submodelinfos = ((org.w3c.dom.Element)lnodes.item(i)).getChildNodes();
				
					// Model params.
				int sstate=0;
				String dist1=null, dist2=null;
				double [] law1Params=null;				
				double [] law2Params=null;
				int dec=1;
				AudioCodec ocodec=null;
				
				for (int j=0; j < submodelinfos.getLength() ; j++) {
					if ( ((org.w3c.dom.Element)submodelinfos.item(j)).getNodeName().equals("sstate"))
						sstate=Integer.valueOf(((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("value")).intValue();

					if ( ((org.w3c.dom.Element)submodelinfos.item(j)).getNodeName().equals("distribution1")) {
						dist1=((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("name");
						if (dist1.equals("Poisson") || dist1.equals("Exponential") || 
							dist1.equals("Constant") || dist1.equals("Geometric")) {
							law1Params = new double[1];
						}
						else {
							law1Params = new double[2];
							law1Params[1] =Double.valueOf(((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("param2")).doubleValue();
						}
						law1Params[0]=Double.valueOf(((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("param1")).doubleValue();
					}
						
					if ( ((org.w3c.dom.Element)submodelinfos.item(j)).getNodeName().equals("distribution2")) {
						dist2=((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("name");
						if (dist2.equals("Poisson") || dist2.equals("Exponential") || 
							dist2.equals("Constant") || dist2.equals("Geometric")) {
							law2Params = new double[1];
						}
						else {
							law2Params = new double[2];
							law2Params[1] =Double.valueOf(((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("param2")).doubleValue();
						}
						law2Params[0]=Double.valueOf(((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("param1")).doubleValue();
					}
					
						// Rebuild the codec.
					if ( ((org.w3c.dom.Element)submodelinfos.item(j)).getNodeName().equals("codec")) {
						String cname = ((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("name");
						double iptime = Double.valueOf(((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("iptime")).doubleValue();
						int psize = Integer.valueOf(((org.w3c.dom.Element)submodelinfos.item(j)).getAttribute("psize")).intValue();
						ocodec = new AudioCodec( psize, iptime, cname);
					}
				}
				GenericDistribution law1 = utils.ObjectConstructor.createDistribution( dist1, law1Params);
				GenericDistribution law2 = utils.ObjectConstructor.createDistribution( dist2, law2Params);
				models[flowNo-1] = new OnOffModel (sstate, law1, law2, ocodec);
			}
		}
	}
	
	public void constructModelGenerator() throws IOException {
		
		oohafm = new OnOffHeterogeneousAggregatedFlowModel(models, sourceNumber);
		oohafg = new OnOffHeterogeneousAggregatedFlowGeneration(duration, oohafm, 1260);
		//oohafg.flowScenariiGeneration();
		
		oohafg.setUnit((short)0);
		oohafg.setGraphicMode(true);

		genericAggModel = oohafm;
		genericGen = oohafg;
	}
}
