package graphics2.panel.client;

/**
 * You specify test duration in hour and minutes
 * 	This is used by ScenarioFilePanel to generate a default scenario file name
 * 
 * @author mladoue
 * @version 0.1, 27/05/03
 */


import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

import utils.MessageManager;


public class TimePanel extends JPanel  implements ActionListener {

	private JTextField hour,minutes;
	private JLabel result = new JLabel("=>"), resultMinutes;
	protected ParamListener paramListener;
	protected ClientPanel clientPanel;


public TimePanel(ClientPanel cp) {
	
	// To listen hour and minutes field
	paramListener = new ParamListener();
	
	this.setLayout( new BoxLayout(this,BoxLayout.Y_AXIS));
	
	JPanel panel1 = new JPanel();
	panel1.setLayout(new BoxLayout(panel1,BoxLayout.X_AXIS));
    
	JPanel panel11 = new JPanel();
	panel11.setLayout(new BoxLayout(panel11,BoxLayout.X_AXIS));

	panel11.add( new JLabel("Duration :") );
	panel11.add(Box.createRigidArea(new Dimension(20,0)));
	panel11.add( hour = new JTextField("0",6));
	hour.setMaximumSize(new Dimension(hour.getPreferredSize().width, 
															  hour.getPreferredSize().height));
	hour.addKeyListener(paramListener);
	panel11.add(Box.createRigidArea(new Dimension(5,0)));
	panel11.add( new JLabel("hours") );
	
	panel11.add(Box.createRigidArea(new Dimension(30,0)));
	panel11.add( minutes = new JTextField("30",6));
	minutes.setMaximumSize(new Dimension(minutes.getPreferredSize().width, 
																	minutes.getPreferredSize().height));

	minutes.addKeyListener(paramListener);
	panel11.add( Box.createRigidArea(new Dimension(5 ,0)));
	panel11.add( new JLabel("minutes") );

	JPanel panel12 = new JPanel();
	panel12.setLayout(new BoxLayout( panel12,BoxLayout.X_AXIS));
	
	panel12.add( result );
	panel12.add(Box.createRigidArea( new Dimension(10,0)) );
	int startDuration = getDuration();
	panel12.add( resultMinutes = new JLabel("     " + startDuration));
	resultMinutes.setMaximumSize(new Dimension(resultMinutes.getPreferredSize().width, 
																			resultMinutes.getPreferredSize().height));
	panel12.add(Box.createRigidArea(new Dimension(10,0)));
	panel12.add( new JLabel("minutes") );

	panel1.add(Box.createHorizontalGlue());
	panel1.add(Box.createRigidArea(new Dimension(10,0)));
	panel1.add(panel11);
	panel1.add(Box.createRigidArea(new Dimension(10,0)));
	panel1.add(panel12);
	panel1.add(Box.createHorizontalGlue());
	
	this.add(panel1);
	
	setBorder(new TitledBorder("Test duration"));
	}
	
	
	
	/**
	 * To set the duration transform in an hours part and minutes part
	 * @param duration in mimutes
	 * @throws NumberFormatException
	 * void
	 */
	public void setDuration( short duration ) throws NumberFormatException {
	   if  ( duration>=0 ) {
		   hour.setText( String.valueOf( duration/60 ) );
		   minutes.setText( String.valueOf(duration % 60) );
			resultMinutes.setText( ""+duration );
	   }
	   else {  throw new NumberFormatException ("TimePanel.setDuration : Invalide value");}
	}
		 
/**
   * Returns test duration specified in the GUI in minutes
   * @see graphics.ClientInfo#getDuration()
   */
  public short getDuration() throws NumberFormatException {
	  short h=0,m=0;
	  if ( ( (minutes.getText()).equals(new String("")) ) && ( (hour.getText()).equals(new String("")) ) ) {
		MessageManager.warningMessage("There is no test duration specify. Set to default", true);
		hour.setText("0");
		minutes.setText("30"); 
	  }
	  if ((minutes.getText()).equals(new String(""))) {
	  	m=0;
	  }
	  else {
	  	if (Short.parseShort(minutes.getText()) > 60) {
			MessageManager.errorMessage("You must specify a minute number between 0 and 59!", true);
			minutes.setText("30");
	  	} 
	  	m = (short)(Short.parseShort(minutes.getText()));
	  }
	  	
	  if ((hour.getText()).equals(new String(""))) {
	  	h=0;
	  }	
	  else {
		   h = (short)(Short.parseShort(hour.getText()));
		   h *= 60;
	  }
	  return (short)(h+m);
  }	
  
  public void freezeInfo( boolean b ) {
	  hour.setEditable(!b);
	  minutes.setEditable(!b);
	  resultMinutes.setEnabled(!b);
  }
  
  public void reset() {
	  hour.setText("");
	  minutes.setText("");
	  resultMinutes.setText("0");
	  
	  hour.setEnabled(true);
	  minutes.setEnabled(true);
  }
  
  
   public void actionPerformed(ActionEvent e) {
  }
  
   public void updateResultMinutes() { resultMinutes.setText( Short.toString(getDuration()) ); }
  
  
  // Classe interne
  class ParamListener implements KeyListener {
  		public void keyPressed(KeyEvent e) {
  			// Do nothing
  		}
		public void keyReleased(KeyEvent e) {
			resultMinutes.setText( Short.toString(getDuration()) ); 			
		}
 		public void keyTyped(KeyEvent e){
 			// Do nothing
		}
   }
  
}
