package graphics2.panel.client.model;

/**
 * MMPPNModelPanel
 * 
 * @author mladoue
 * @version 0.1, 14/01/03 
 */



import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import utils.MessageManager;
import multimedia.model.*;
import graphics2.panel.client.InterneModelPanel;

public class MMPPNModelPanel extends GenericModelPanel  {

	protected JLabel[] paramName = new JLabel[3];  // alpha, beta and lambda
  	protected JTextField[] paramValue = new JTextField[3];
	protected JLabel nbEtatL,etatDepartL;
	protected JTextField nbEtatF,etatDepartF;
	protected TitledBorder tb;
		
	protected ParamListener paramListener;


/**
 * MMPPNModelPanel : default constructor
 */
public MMPPNModelPanel() {
	super();
 	modelType = AUDIO;
 	modelParametersNumber = 5;
}

/**
 * MMPPNModelPanel
 * 
 * @param imp
 */
public MMPPNModelPanel(InterneModelPanel imp) {
    super(imp);
 	modelType = AUDIO;
 	modelParametersNumber = 5;
	
	 
	 	JPanel mmppnPanel = new JPanel();
		JScrollPane scroller = new JScrollPane(mmppnPanel);
		mmppnPanel.setLayout( new BoxLayout(mmppnPanel,BoxLayout.Y_AXIS) );
	
		this.setLayout(new BorderLayout());

	paramListener = new ParamListener();

		paramName = new JLabel[3];
	    paramValue = new JTextField[3];

	JPanel panel1 = new JPanel();
	panel1.setLayout(new BoxLayout(panel1,BoxLayout.X_AXIS));
 	panel1.add(Box.createRigidArea(new Dimension(40,0)));
  	panel1.add(nbEtatL = new JLabel("State numbers : ") );
  	panel1.add(Box.createRigidArea(new Dimension(14,0)));
   	panel1.add(nbEtatF = new JTextField("2",7));
	nbEtatF.setMaximumSize(new Dimension(nbEtatF.getPreferredSize().width, 
																   nbEtatF.getPreferredSize().height));
	panel1.add(Box.createHorizontalGlue());
  
  	JPanel panel2 = new JPanel();
	panel2.setLayout(new BoxLayout(panel2,BoxLayout.X_AXIS));
 	
 	panel2.add(Box.createRigidArea(new Dimension(40,0)));
    panel2.add(etatDepartL = new JLabel("Start state : ") );
    panel2.add(Box.createRigidArea(new Dimension(40,0)));
    panel2.add(etatDepartF = new JTextField("1",7));
	etatDepartF.setMaximumSize(new Dimension(etatDepartF.getPreferredSize().width, 
																		 etatDepartF.getPreferredSize().height));
	panel2.add(Box.createHorizontalGlue());
	    
	    
	  JPanel panel3 = new JPanel();
	panel3.setLayout(new BoxLayout(panel3,BoxLayout.X_AXIS));
 	panel3.add(Box.createRigidArea(new Dimension(40,0)));
   	panel3.add( paramName[0]= new JLabel("Alpha : "));
   	panel3.add(Box.createRigidArea(new Dimension(68,0)));
    panel3.add ( paramValue[0] = new JTextField("",7) );
	paramValue[0].setMaximumSize(new Dimension(paramValue[0].getPreferredSize().width, 
																			  paramValue[0].getPreferredSize().height));
    panel3.add(Box.createRigidArea(new Dimension(50,0)));
	panel3.add(MessageManager.createHelpMessageDialogButton("Help window...to do"));
	panel3.add(Box.createHorizontalGlue());
   	  		
    	  		
   	JPanel panel4 = new JPanel();
	panel4.setLayout(new BoxLayout(panel4,BoxLayout.X_AXIS));
 	panel4.add(Box.createRigidArea(new Dimension(40,0)));	
      	//paramName[1].setHorizontalAlignment(JLabel.RIGHT);
        panel4.add( paramName[1]= new JLabel("Beta : "));
        panel4.add(Box.createRigidArea(new Dimension(77,0)));
      	panel4.add( paramValue[1] =new JTextField("",7));
	paramValue[1].setMaximumSize(new Dimension(paramValue[1].getPreferredSize().width, 
																			  paramValue[1].getPreferredSize().height));
	panel4.add(Box.createHorizontalGlue());
     	
      	
      	JPanel panel5 = new JPanel();
		panel5.setLayout(new BoxLayout(panel5,BoxLayout.X_AXIS));
 		panel5.add(Box.createRigidArea(new Dimension(40,0)));	
        panel5.add( paramName[2] = new JLabel("Lambda : ") );
        panel5.add(Box.createRigidArea(new Dimension(55,0)));
      	panel5.add ( paramValue[2] = new JTextField("",7));
		paramValue[2].setMaximumSize(new Dimension(paramValue[2].getPreferredSize().width, 
																			  	  paramValue[2].getPreferredSize().height));
		panel5.add(Box.createHorizontalGlue());


		mmppnPanel.add(panel1);
		mmppnPanel.add(Box.createRigidArea(new Dimension(0,5)));
		mmppnPanel.add(panel2);
		mmppnPanel.add(Box.createRigidArea(new Dimension(0,5)));
		mmppnPanel.add(panel3);
		mmppnPanel.add(Box.createRigidArea(new Dimension(0,5)));
		mmppnPanel.add(panel4);
		mmppnPanel.add(Box.createRigidArea(new Dimension(0,5)));
		mmppnPanel.add(panel5);
		mmppnPanel.add(Box.createRigidArea(new Dimension(0,5)));

		add(mmppnPanel);
	
	 // Set the Border
	  tb = new TitledBorder("MMPP-" + ((MMPPNModel)(imp.getModelPanel().getModelTest())).getEtatCount() +" Model features"); 
	  setBorder(tb);
}



 	public String getNbEtat() throws NullPointerException {	return nbEtatF.getText();  }
    
    public int getStartState( ) { return Integer.parseInt(etatDepartF.getText()); }
	
	/**
	 * Method getParam.
	 * @param idx 0: alpha, 1:beta, 2:lambda
	 * @return double
	 */
	public double getParam(int idx) throws IllegalArgumentException {
		String ans = "";
		if(idx>2 || idx<0) {
     		throw new IllegalArgumentException("There isn't " + idx + " parameter");
     	}
     	else {
     			ans = paramValue[idx].getText();
     			if ( ans.equals("") || ans.equals(" ") ) {
     				ans = "0";	
     			} 
			return Double.parseDouble(ans);
     	}
	}
    
     public void setNbEtat(int nbEtat) throws IllegalArgumentException { nbEtatF.setText("" + nbEtat);  }
    
    public void setStartState(int state) throws IllegalArgumentException { etatDepartF.setText("" + state);	}
	/**
	 * Method setParam.
	 * @param idx 0: alpha, 1:beta, 2:lambda
	 * @param value
	 * @throws IllegalArgumentException
	 */
     public void setParam(int idx,double value) throws IllegalArgumentException {
		paramValue[idx].setText("" + value);
	}
    

class ParamListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      //setBorder(new TitledBorder("MMPP-" + getNbEtat()  +" Model features") );
      tb.setTitle("MMPP-" + nbEtatF.getText()  +" Model features");
    }
  }

  public void freezeInfo(boolean b) {
  	
  	for ( int i=0;i<3;i++) {
  		paramValue[i].setEditable(!b);
  	}
  	nbEtatF.setEditable(!b);
  	etatDepartF.setEditable(!b);
  }

public void reset() {
	for (int i=0;i<3;i++) {
		paramValue[i].setText("");
	}
	nbEtatF.setText("");
	etatDepartF.setText("1");  // default value
}

	public boolean isAValidModel() {
		if (isAnInt(getNbEtat(), "State Numbers") &&
			isAnInt(etatDepartF.getText(), "Start state") &&
			isAFloat(paramValue[0].getText(), "Alpha") &&
			isAFloat(paramValue[1].getText(), "Beta") &&
			isAFloat(paramValue[2].getText(), "Lambda"))
			return true;
		else
			return false;
	}
	
    public org.w3c.dom.Element buildNewXmlNode() {
            // data values in the Panel should be ok
            // Access Configuration Tree.
        graphics2.ConfigurationXMLFile conftree = imp.getModelPanel().getClientPanel().getListScenario();
        org.w3c.dom.Element elem = conftree.createNewXMLElement("scenario_mmppn");
        
            // Add the model.
        org.w3c.dom.Element modelchild = conftree.createElement("model");
        modelchild.setAttribute("name", "MMPPN");
        elem.appendChild(modelchild);
	
		 // Add state value node to the model
		org.w3c.dom.Element statenumber = conftree.createElement("statenumber");
		statenumber.setAttribute("value", String.valueOf(getNbEtat()));
		modelchild.appendChild(statenumber);
	
                 // Add state value node to the model
        org.w3c.dom.Element statechild = conftree.createElement("sstate");
        statechild.setAttribute("value", String.valueOf(getStartState()));
        modelchild.appendChild(statechild);

            // Add alpha value node to the model
        org.w3c.dom.Element alphachild = conftree.createElement("alpha");
        alphachild.setAttribute("value", paramValue[0].getText());
        modelchild.appendChild(alphachild);

            // Add beta value node to the model
        org.w3c.dom.Element betachild = conftree.createElement("beta");
        betachild.setAttribute("value", paramValue[1].getText());
        modelchild.appendChild(betachild);
  
            // Add lambda1 value node to the model
        org.w3c.dom.Element lambda1child = conftree.createElement("lambda1");
        lambda1child.setAttribute("value", paramValue[2].getText());
        modelchild.appendChild(lambda1child);
        
        return elem;
    }

	public void updateWithXmlNode(org.w3c.dom.Element elt) {
		if (! elt.getAttribute("name").equals("MMPPN")) {
			// Error
			System.out.println("Wrong model name: "+elt.getAttribute("name")+" in MMPPNModelPanel");	
		}
		else {
			org.w3c.dom.NodeList nlist = elt.getChildNodes() ;
			for (int i=0; i < nlist.getLength(); i++) {
				String name = nlist.item(i).getNodeName();
				if (name.equals("sstate"))
					setStartState(Integer.valueOf( ((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).intValue() );
				else if(name.equals("statenumber"))
					setNbEtat(Integer.valueOf( ((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).intValue() );
				else if(name.equals("alpha")) 
					setParam(0, Double.valueOf(((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).doubleValue());
				else if(name.equals("beta"))
					setParam(1, Double.valueOf(((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).doubleValue());
				else if(name.equals("lambda1"))
					setParam(2, Double.valueOf(((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).doubleValue());
				else if(name.equals("lambda2"))
					setParam(3, Double.valueOf(((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).doubleValue());
			}
		}
	}
}
