package graphics2.panel.client.model;

/**
 * OnOffHeterogeneousAggregatedFlowModelPanel 
 * 
 * @author mladoue
 * @version 0.1, 02/04/03 
 */

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.border.*;

import org.w3c.dom.Element;

import multimedia.codec.AudioCodec;
import multimedia.model.OnOffModel;
import utils.*;
import utils.definitions.*;
import graphics2.panel.*;
import graphics2.panel.client.*;

public class OnOffHeterogeneousAggregatedFlowModelPanel extends GenericModelPanel implements DefaultObjectDefinitions {

	protected OnOffModelPanel onoffPanel;
	protected CodecPanel codecPanel;
	protected final FlowTreePanel mdt = new FlowTreePanel("Flows description list");
	protected int flowsNumber = 0;  // nb de flows existants
	private int nodeNumber = 0;  // numero du prochain flot pouvant etre cree
	private Vector flowValue = new Vector(10); 	// liste des noeuds correspondant aux flots: les elements sont des DefaultMutableTreeNode
	private Vector modelValue = new Vector(10);  // savoir s'il y a ou non un model definit pour le flow correspondant
	private Vector codecValue = new Vector(10); // savoir s'il y a ou non un codec definit pour le flow correspondant
	private Toolkit toolkit = Toolkit.getDefaultToolkit();
	
	private JButton reset = new JButton("Reset Model");
	private JButton addModel = new JButton("Add model");
	private JButton removeModel = new JButton("Remove  model");
	private JButton clearFlow = new JButton("Clear");
	private	JLabel srcNb = new JLabel("Number of sources for this flow: ");
	private JTextField nb = new JTextField("",3);
	
	
	public OnOffHeterogeneousAggregatedFlowModelPanel() {
		super();
 		modelType = AUDIO;
 		modelParametersNumber = 1;   // minumum number of parameters
	}
	
	public OnOffHeterogeneousAggregatedFlowModelPanel(InterneModelPanel imp) {
		super(imp);
		modelType = AUDIO;
		modelParametersNumber = 1;   // minumum number of parameters
		
		JPanel onoffaggPanel = new JPanel();
		onoffaggPanel.setLayout( new BoxLayout(onoffaggPanel,BoxLayout.X_AXIS) );
	
		this.setLayout(new BorderLayout());
	
		JPanel panel1 = new JPanel();
		panel1.setLayout(new BoxLayout(panel1,BoxLayout.Y_AXIS));
	
		JPanel panel12 = new JPanel();
		panel12.setLayout(new BoxLayout(panel12,BoxLayout.Y_AXIS));
		
		panel12.add(Box.createRigidArea(new Dimension(0,5)));	
		onoffPanel = new OnOffModelPanel(imp,"On-Off Markovian Model features");
		
		onoffPanel.distPanel[0].setDistributionName("Exponential");
		onoffPanel.distPanel[1].setDistributionName("Exponential");
		
		panel12.add(Box.createRigidArea(new Dimension(0,5)));
	
			// Create buttons	
		JPanel panel121 = new JPanel();
		panel121.setLayout(new BoxLayout(panel121,BoxLayout.X_AXIS));
		panel121.add(Box.createRigidArea(new Dimension(50,0)));	
		panel121.add(reset);
		panel121.add(Box.createRigidArea(new Dimension(20,0)));
		panel121.add(addModel);
		panel121.add(Box.createRigidArea(new Dimension(20,0)));	
		panel121.add(removeModel);
		panel121.add(Box.createRigidArea(new Dimension(50,0)));
		
		panel12.add(panel121);
		panel12.add(Box.createRigidArea(new Dimension(0,5)));

			// Set number of sources		
		JPanel panel11 = new JPanel();
		panel11.setLayout(new BoxLayout(panel11,BoxLayout.X_AXIS));
		panel11.add(Box.createRigidArea(new Dimension(50,0)));	
		panel11.add(srcNb);
		panel11.add(Box.createRigidArea(new Dimension(20,0)));	
		panel11.add(nb);
		nb.setEditable(true);
		nb.setMaximumSize(new Dimension(nb.getPreferredSize().width, 
																nb.getPreferredSize().height));


			// Button to clear all the flows		
		JPanel panel13 = new JPanel();
		panel13.setLayout(new BoxLayout(panel13,BoxLayout.X_AXIS));
		panel13.add(clearFlow);
		panel13.add(Box.createRigidArea(new Dimension(10,0)));	

			// Codec Panel		
		JPanel panel14 = new JPanel();
		panel14.setLayout(new BoxLayout(panel14,BoxLayout.Y_AXIS));
		panel14.add(Box.createRigidArea(new Dimension(0,5)));	
		codecPanel = new CodecPanel(imp);
		panel14.add(codecPanel);
		panel14.add(Box.createRigidArea(new Dimension(0,5)));	

			// Add all the lement to the main Panel.		
		panel1.add(panel11);
		panel1.add(Box.createRigidArea(new Dimension(0,5)));
		panel1.add(onoffPanel);
		panel1.add(Box.createRigidArea(new Dimension(0,5)));
		panel1.add(panel14);
		panel1.add(Box.createRigidArea(new Dimension(0,15)));
		panel1.add(panel12);
		panel1.add(Box.createRigidArea(new Dimension(0,5)));
		panel1.add(panel13);
		panel1.add(Box.createRigidArea(new Dimension(0,15)));
		
	
		JPanel panel2 = new JPanel();
		panel2.setLayout(new BoxLayout(panel2,BoxLayout.Y_AXIS));
		panel2.add(mdt);
	
		onoffaggPanel.add(panel1);
		onoffaggPanel.add(Box.createRigidArea(new Dimension(10,0)));
		onoffaggPanel.add(panel2);
		
		add(onoffaggPanel);
		
		makeButtons();
		
		//Positionner le nb de parametre
		setModelParametersNumber();
		System.out.println("ciccc");
		onoffPanel.distPanel[0].freezeDistributionName(true);
		onoffPanel.distPanel[1].distributionName.setEnabled(false);

		 // Set the Border
    	setBorder( new TitledBorder("On-Off Heterogeneous Aggregated Flows Model features") );
	}
	
	/**
	 * Make the buttons to add/remove a flow, a codec and a model and clear all
	 */
	protected void makeButtons() {
		
		reset.addActionListener( new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					onoffPanel.reset();
				}
			});
		// Model
		addModel.addActionListener( new AddOnOffModel() );
		
		removeModel.addActionListener( new RemoveOnOffModel());
		
		clearFlow.addActionListener( new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						flowValue.clear();
						codecValue.clear();
						modelValue.clear();
						mdt.clear();
						nodeNumber =0;
						flowsNumber = 0;
					}
				});	
	}
	
	
	public int getFlowTypeNumber() { return mdt.getFlowNumber(); }
	
	public int getCurrentFlowSelection() { return (mdt.getCurrentFlowSelection()+1); }
	
	public String getCurrentFlowDefinition() { return mdt.getCurrentFlowDescription(); }
	
	public void setFlowNumber( int flowsNumber ) { this.flowsNumber = flowsNumber; }


	//  Definitions des fonctions permettant de recuperer et positionner les parametres de l'interface 
	
	/**
	 * Returns a definition of the specified flow type 
	 * @param flowNumber	 it's an int between 1 and N
	 * @return String like: "Flow 1 : 10 source(s)."
	 */		
	public String getSpecificFlowDefinition( int flowNumber ) {
		flowsNumber = getFlowTypeNumber();
		if( flowsNumber >= flowNumber && flowNumber> 0) {
			return mdt.getSpecificFlow(flowNumber-1);
		}
		else { throw MyExceptionDefinitions.FLOW_EXISTENCE; }
	}
	
	/**
	 * @param idx between 1 and nbDifferentFlow
	 * @return the number of source for the specified flow
	 */
	public int getFlowSourceNumber( int idx) {
		if( idx>0 && idx<=flowsNumber ) {
			String flow = getSpecificFlowDefinition(idx);
			int number = Integer.parseInt( flow.split(" ", 5)[3] );	//"Flow " + flowNumber + " : " + sourcesNumber + " source(s).
			return number;
		}
		else { throw MyExceptionDefinitions.BAD_INDEX_ACCESS; }
	}
	
	
	/**
	 * To set for a specified flow a source number
	 * @param flowNumber  it's an int between 1 and N
	 * @param sourcesNumber
	 */
	public void setSpecificFlowDefinition( int flowNumber, int position, int sourcesNumber) {
		flowValue.add( position-1, mdt.addObject( null,"Flow " + flowNumber + " : " + sourcesNumber + " source(s).", true));
		modelValue.add( position-1, DEFAULT_NODE);  // au cas ou  on depasserait les 10 fllux d'initialisation
		codecValue.add( position-1, DEFAULT_NODE);
	}
	
	/**
	 * Returns a description of the specified flow type
	 * @param flowNumber	it's an int between 1 and N 
	 * @return a String like:  "Model On-Off:  0 Pareto Normal 10 20 34 40"
	 */
	public String getSpecificOnOffModelDefinition( int flowNumber ) {
		flowsNumber = getFlowTypeNumber();
		if( (flowsNumber >= flowNumber) && flowNumber> 0) {
			
			if( modelValue.elementAt(flowNumber-1).equals(DEFAULT_NODE) ) {
				System.out.println("MyDynamicTree.getChildDefinition:  Error:  No model is defined for this flow: " +  (flowNumber + 1) +" !");
				setModelObject( flowNumber-1, DEFAULT_ONOFF_MODEL_DESCRIPTION.split(" "));
			}
			//System.out.println("Model definition: " + mdt.getChildDefinition( flowNumber-1, 0, modelValue));
			return mdt.getChildDefinition( flowNumber-1, 0);
			
		}
		else { throw MyExceptionDefinitions.FLOW_EXISTENCE; }
	}
	
	public void setSpecificOnOffModelDefinition( int flowNumber, String onoffModelParametersDescription) {
		setModelObject(flowNumber-1, onoffModelParametersDescription.split(" "));
	}
	
	/**
	 * Returns a description of codec
	 * @param flowNumber it's an int between 1 and N 
	 * @return a codec definition in String form like : Codec: G726 104 0.016 
	 */
	public String getSpecificCodecDefinition( int flowNumber ) {
		flowsNumber = getFlowTypeNumber();
		if( (flowsNumber >= flowNumber) && flowNumber> 0) {
		
			if( codecValue.elementAt(flowNumber-1).equals(DEFAULT_NODE) ) {
				System.out.println("MyDynamicTree.getChildDefinition:  Error:  No model is defined for this flow: " +  (flowNumber + 1) +" !");
				setCodecObject( flowNumber-1, DEFAULT_AUDIO_CODEC_DESCRIPTION);
				//codecValue.add( flowNumber-1, DEFAULT_AUDIO_CODEC_DESCRIPTION);
			}
			//System.out.println("Codec definition: " + mdt.getChildDefinition(flowNumber-1, 1,codecValue));
			
			return mdt.getChildDefinition(flowNumber-1, 1);
		}
		else {
			//throw FLOW_EXISTENCE;  //throw new IllegalArgumentException("There are only:" + existentFlowNumber +" defined flows!"); }
			throw new IllegalArgumentException("There are only:" + flowsNumber +" defined flows instad of :"+ flowNumber + "!");
		}
	}
	
	public void setSpecificCodecDefinition( int flowNumber, String codecParametersDescription) {
		setCodecObject(flowNumber-1, codecParametersDescription);
	}
	
	
	 public void freezeInfo(boolean b) {
  		
		onoffPanel.freezeInfo(b);
		codecPanel.freezeInfo(b);
		onoffPanel.freezeInfo(b);
		addModel.setEnabled(!b);
		removeModel.setEnabled(!b);
		clearFlow.setEnabled(!b);
		reset.setEnabled(!b);
		nb.setEnabled(!b);
	}
	
	public void reset() {
		
		onoffPanel.distPanel[0].setDistributionName("Exponential");
		onoffPanel.distPanel[1].setDistributionName("Exponential");
		onoffPanel.distPanel[0].freezeDistributionName(true);
		onoffPanel.distPanel[1].freezeDistributionName(true);
		codecPanel.reset();
		nb.setText("");
		addModel.setEnabled(true);
		removeModel.setEnabled(true);
		clearFlow.setEnabled(true);
		reset.setEnabled(true);
		//clearFlow.	//TODO
	}
	
	/**
	 * Method setModelParametersNumber
	 */
	protected void setModelParametersNumber() {
		modelParametersNumber = 1;  // correspond au nombre de flots
		flowsNumber = getFlowTypeNumber();
		String[] modelD;
		for (int i=1;i<=flowsNumber;i++) {
			modelD = getSpecificOnOffModelDefinition(i).split(" ");
			modelParametersNumber += modelD.length-1;  // on enleve Model et OnOff: et on ajout le nb de source de chq type 
		}
		modelParametersNumber += (flowsNumber-1); // On ajoute (N-1) fois le symbole | qui separe les differents flots
	}
	
	
	public int getParametersNumber() {
		setModelParametersNumber();
		return modelParametersNumber;	
	}
	
	/**
	 * Method setModelObject
	 * @param flowNumber it's an int between 0 and N
	 * @param ans
	 */
	public void setModelObject( int flowNumber, String[] ans) {
		
		if( flowNumber>=0 && (modelValue.elementAt(flowNumber)).equals(DEFAULT_NODE) ) {
			DefaultMutableTreeNode newModel = mdt.addObject((DefaultMutableTreeNode)flowValue.elementAt(flowNumber) ,"Model On-Off: " + MyTableOperation.transformST2S(ans), true);
			newModel.setAllowsChildren(false);
			modelValue.set( flowNumber, newModel);
		}
		else {
			toolkit.beep();
			System.out.println("Flow number: " + flowNumber + " params: " + MyTableOperation.transformST2S(ans));	 //DEBUG
			MessageManager.informationMessage( "You must specify only one model for a flow!!!", true);
		 }	
	}
	
	/**
	 * Method setCodecObject
	 * @param flowNumber it's an int between 0 and N
	 * @param ans
	 */
	public void setCodecObject( int flowNumber, String ans) {
		
		if(  flowNumber>=0 && (codecValue.elementAt(flowNumber)).equals(DEFAULT_NODE) ) {
			DefaultMutableTreeNode newCodec = mdt.addObject((DefaultMutableTreeNode)flowValue.elementAt(flowNumber) ,"Codec: " + ans, true);
			newCodec.setAllowsChildren(false);
			codecValue.set( flowNumber, newCodec);
		}
		else { 
			toolkit.beep();
			System.out.println("Codec: " + flowNumber + " params: " + ans);  //DEBUG
			MessageManager.informationMessage( "You must specify only one codec for a flow!!!", true);
		 }	
	}
	
	
	public OnOffModel getModel(int idx) {
		OnOffModel model = onoffPanel.getModel();
		model.setCodec((AudioCodec)codecPanel.getCodec());
		return model;
	}
	
	/**
	 *  Internal class :   AddOnOffModel 
	 */
	protected class AddOnOffModel implements ActionListener {
		private int currentFlow = 0;
		private String[] ans;  // model parameters 
		
		public void actionPerformed(ActionEvent e) {
			// First, check that the model is valid before adding it !
			if (onoffPanel.isAValidModel() &&
				isAPosInt(nb.getText(), "Source number")) {

				// OnOff agg model had another constraint: Nbsource must be > (alpha+beta)/beta
				double alpha = Double.parseDouble(onoffPanel.getDistributionParameters(0)[0]);
				double beta = Double.parseDouble(onoffPanel.getDistributionParameters(1)[0]);
				if (Double.parseDouble(nb.getText()) < (alpha+beta)/beta) {
					MessageManager.informationMessage( "Sorry, this model cannot be added:\n" +
						"source number must be superior to (lambda1+lambda2)/lambda2 !", true);			
				}
				else { // The model can be constructed.
					flowsNumber++;
					nodeNumber++;
					setSpecificFlowDefinition( nodeNumber, flowsNumber, Integer.parseInt(nb.getText()));

					currentFlow = flowsNumber;//mdt.getFlowNumber()-1;  // entre 0 et N
					System.out.println("position="+currentFlow);
					// Add the flow based on the onoff model
					ans =  new String[onoffPanel.getParametersNumber()];
					int distParamNb =0, distParamNbOld=0;
					ans[0] = new String ("" + onoffPanel.getStartState());
					for ( int i=0;i<2;i++) {
						ans[i+1] = onoffPanel.getDistributionName(i);  //nom des distribs				
						distParamNb = onoffPanel.getDistributionPanel(i).getDistribution().getParamsCount();
						for ( int j=0;j<distParamNb;j++ ) {
							try{
								ans[distParamNbOld+3+j] = (onoffPanel.getDistributionParameters(i))[j];
							}
							catch(ArrayIndexOutOfBoundsException aie) { System.out.println(aie);	}
						}
						distParamNbOld += distParamNb;
					}
					setModelObject( currentFlow-1, ans);
	
					// Add the codec...
					codecPanel.updateParam();
					String code = codecPanel.getCodec().toString();	
					setCodecObject( currentFlow-1, code);
				}
			}
		}
	}

	protected class RemoveOnOffModel implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			// First, since the user can select the flow, the model or the codec,
			// find the position of the flow...
			if (mdt.getTree().getSelectionPath() ==null || !mdt.isAFirstLevelParent()) {
				MessageManager.informationMessage( "Please, first select the flow you want to remove!", true);
			}	
			else {
				// Plutot que le mettre a DEFAULT_NODE, on efface dans les vecteurs, ce qui
				// a pour effet de tout decaller d'un cran les elements, comme le fait mdt !
				flowValue.removeElementAt(mdt.getCurrentFlowSelection());
				modelValue.removeElementAt(mdt.getCurrentFlowSelection());
				codecValue.removeElementAt(mdt.getCurrentFlowSelection());
				
				// Si on n'est pas sur le parent, remonter sur le parent !
				mdt.removeCurrentNode();
				flowsNumber--;
			}
		}
	}
	
	/*
	 * Only check that the list is not empty !
	 * @see graphics2.panel.client.model.GenericModelPanel#isAValidModel()
	 */
	public boolean isAValidModel() {
		if (flowsNumber > 0)
			return true;
		else {
			JOptionPane.showMessageDialog(this, "Empty flow list. First add a flow before adding it to the scenario!","Empty flow list",JOptionPane.ERROR_MESSAGE);
			return false;
		}
	}
	/* (non-Javadoc)
	 * @see graphics2.panel.models.GenericModelPanel#buildNewXmlNode()
	 */
	public Element buildNewXmlNode() {
		graphics2.ConfigurationXMLFile conftree = imp.getModelPanel().getClientPanel().getListScenario();
		org.w3c.dom.Element elem = conftree.createNewXMLElement("scenario_onoffheterogeneousaggregatedflow");
        
			// Add the model.
		org.w3c.dom.Element modelchild = conftree.createElement("model");
		modelchild.setAttribute("name", "OnOffHeterogeneousAggregatedFlow");
		modelchild.setAttribute("aggregated", "true");
		elem.appendChild(modelchild);
		
			// This is an aggregated model
			// iterate the list of models...
		for (int i=0; i < flowsNumber ; i++) {
			org.w3c.dom.Element agreg = conftree.createElement("submodel");
			agreg.setAttribute("name", "OnOff");

			DefaultMutableTreeNode node = (DefaultMutableTreeNode)flowValue.get(i);
			String nbsStr[] = node.toString().split(" ");
			agreg.setAttribute("number", nbsStr[1]);
			agreg.setAttribute("nbsources", nbsStr[3]);
					
			DefaultMutableTreeNode modelTree = (DefaultMutableTreeNode)modelValue.get(i);
			if (modelTree != null) {
				// Extract model information from the string.
				String[] modelString = modelTree.toString().split(" ");
				// State
				org.w3c.dom.Element statechild = conftree.createElement("sstate");
				statechild.setAttribute("value", modelString[2]);
				agreg.appendChild(statechild);

				org.w3c.dom.Element d1child = conftree.createElement("distribution1");
				d1child.setAttribute("name", modelString[3]);
				agreg.appendChild(d1child);
			
				org.w3c.dom.Element d2child = conftree.createElement("distribution2");
				d2child.setAttribute("name", modelString[4]);
				agreg.appendChild(d2child);
			
				// depending the number of parameter of each distribution, must add 1 or 2 params.
				int inc=1;
				if (modelString[3].equals( "Poisson") || modelString[3].equals( "Exponential") ||
					modelString[3].equals( "Constant") ||modelString[3].equals( "Geometric") )
					{
						d1child.setAttribute("param1", modelString[5]);
					}
					else {
						d1child.setAttribute("param1", modelString[5]);
						d1child.setAttribute("param2", modelString[6]);
						inc=2;
					}
					// Distribution2 parameters
				if (modelString[4].equals( "Poisson") || modelString[4].equals( "Exponential") ||
					modelString[4].equals( "Constant") ||modelString[4].equals( "Geometric") )
					{
						d2child.setAttribute("param1", modelString[5+inc]);
					}
					else {
						d2child.setAttribute("param1", modelString[5+inc]);
						d2child.setAttribute("param2", modelString[6+inc]);
					}
			}
			
			DefaultMutableTreeNode codecTree = (DefaultMutableTreeNode)codecValue.get(i);
			if (codecValue != null) {
				// Extract codec information
				String[] codecString = codecTree.toString().split(" ");
				
				org.w3c.dom.Element codecelem = conftree.createElement("codec");
				codecelem.setAttribute("type", "Audio");
				
					// Type
				codecelem.setAttribute("name", codecString[1]);
					// Packet Size
				codecelem.setAttribute("psize", codecString[2]);
					// Inter Packet Time
				codecelem.setAttribute("iptime", codecString[3]);
					
				agreg.appendChild(codecelem);
			}
			modelchild.appendChild( agreg);
		}
			// Return the new XML node
		return elem;
	}

	public void updateWithXmlNode(org.w3c.dom.Element elt) {
		// This mainly consist in rebuilding the FlowTreePanel
		mdt.clear();
		nodeNumber =0;
		flowsNumber = 0;

		graphics2.ConfigurationXMLFile conftree = imp.getModelPanel().getClientPanel().getListScenario();

		if (! elt.getAttribute("name").equals("OnOffHeterogeneousAggregatedFlow")) {
			// Error
			System.out.println("Wrong model name: "+elt.getAttribute("name")+" in OnOffHeterogeneousAggregatedFlowPanel");	
		}
		else {
			org.w3c.dom.NodeList lnodes = elt.getElementsByTagName("submodel");
			int flowNo=0;
			for(int i=0; i <lnodes.getLength(); i++) {
				if ( ((org.w3c.dom.Element)lnodes.item(i)).getAttribute("name").equals("OnOff")) {
						// Rebuild the Flow info
					flowNo = Integer.parseInt (((org.w3c.dom.Element)lnodes.item(i)).getAttribute("number"));
					int sourceNb = Integer.parseInt (((org.w3c.dom.Element)lnodes.item(i)).getAttribute("nbsources"));
					flowsNumber++;
					nodeNumber++;
					setSpecificFlowDefinition (flowNo, nodeNumber, sourceNb);
					org.w3c.dom.NodeList modelcodec = ((org.w3c.dom.Element)lnodes.item(i)).getChildNodes();

					String[] params = new String[7];
					for (int j=0; j < 7; j++)
						params[j]="";
					int dec=1;
					for(int j=0; j <modelcodec.getLength(); j++) {
						if ( ((org.w3c.dom.Element)modelcodec.item(j)).getNodeName().equals("sstate"))
							params[0]=((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("value");
	
						if ( ((org.w3c.dom.Element)modelcodec.item(j)).getNodeName().equals("distribution1")) {
							params[1]=((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("name");
							params[3]=((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("param1");
							if (params[1].equals("Poisson") || params[1].equals("Exponential") || 
								params[1].equals("Constant") || params[1].equals("Geometric")) {
							} else {
								params[4] =((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("param2");
								dec=2;
							}
						}
						
						if ( ((org.w3c.dom.Element)modelcodec.item(j)).getNodeName().equals("distribution2")) {
							params[2]=((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("name");
							params[3+dec]=((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("param1");
							if (params[2].equals("Poisson") || params[2].equals("Exponential") || 
								params[2].equals("Constant") || params[2].equals("Geometric")) {
							} else {
								params[4+dec] =((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("param2");
							}						
						}

						if ( ((org.w3c.dom.Element)modelcodec.item(j)).getNodeName().equals("codec")) {
							// Rebuild the codec.
							// <codec type="Audio" name="G726" iptime="0.016" psize="104"/>
							String name = ((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("name");
							String iptime = ((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("iptime");
							String psize = ((org.w3c.dom.Element)modelcodec.item(j)).getAttribute("psize");
							setCodecObject( nodeNumber-1, name+ " " + psize+ " " +iptime);
						}
					}
					setModelObject(nodeNumber-1, params);
				}	
			}
			// nodeNumber should be equals to lnodes.getLength but if an element has been suppress
			// in the list, should be updated to the last flowNo read.
			// This hack prevent to have flow with the same number...
			nodeNumber = flowNo;
		}
	}
}
