package graphics2.panel.control;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;

import utils.MessageManager;

/**
 * 
 * @author mladoue
 * @version 0.1, Jun 16, 2003
 */

public class FileTestParametersPanel extends JPanel {

	private JLabel iptimeMaxL =  new JLabel("Inter-Packet Time: ");
	private JLabel errorMaxL =  new JLabel("Error percentage: ");
	private JLabel iptimeUnit =  new JLabel("ms");
	private JLabel errorUnit =  new JLabel("%");
	private JTextField iptimeMax = new JTextField("20",4);
	private JTextField errorMax = new JTextField("5",4);


public FileTestParametersPanel() {
	
		this.setLayout( new BoxLayout( this, BoxLayout.Y_AXIS));
	
		JPanel ftpPanel = new JPanel();
		ftpPanel.setLayout( new BoxLayout( ftpPanel, BoxLayout.X_AXIS) );
		//	ftpPanel.setPreferredSize(new Dimension(600,20));
	
		// Have to fix the size of JTextField if we want to use createHorizontalGlue
		iptimeMax.setMaximumSize(new Dimension(iptimeMax.getPreferredSize().width, 
																		   iptimeMax.getPreferredSize().height));
		errorMax.setMaximumSize(new Dimension(errorMax.getPreferredSize().width, 
																		  errorMax.getPreferredSize().height));
																		   
																		   
		ftpPanel.add(Box.createRigidArea( new Dimension(50,0)));
		ftpPanel.add(iptimeMaxL);
		ftpPanel.add(Box.createRigidArea( new Dimension(10,0)));
		ftpPanel.add(iptimeMax);
		ftpPanel.add(Box.createRigidArea( new Dimension(5,0)));
		ftpPanel.add(iptimeUnit);
		ftpPanel.add(Box.createRigidArea( new Dimension(30,0)));
		ftpPanel.add(errorMaxL);
		ftpPanel.add(Box.createRigidArea( new Dimension(10,0)));
		ftpPanel.add(errorMax);
		ftpPanel.add(Box.createRigidArea( new Dimension(5,0)));
		ftpPanel.add(errorUnit);
		ftpPanel.add(Box.createRigidArea( new Dimension(30,0)));
		ftpPanel.add(MessageManager.createHelpMessageDialogButton("Not implemented yet!"));		
		ftpPanel.add(Box.createHorizontalGlue());
		
		ftpPanel.setBorder(new TitledBorder("Test file parameters"));
		
		this.add(ftpPanel);
}

public void setErrorMax(String s) { errorMax.setText( s); }

public String getErrorMax() { return errorMax.getText();}

public void setIPtimeMax(String s) { iptimeMax.setText(s);}

public String getIPtimeMax() { return iptimeMax.getText();}


public void freezeInfo(boolean b) {
	iptimeMax.setEnabled(!b);
	errorMax.setEnabled(!b);
}

public void reset() {
	iptimeMax.setText("20");
	errorMax.setText("5");
}

}
