package graphics2.panel.control;

import graphics2.panel.client.*;

import java.awt.*;
import java.awt.event.*;
import java.io.File;

import javax.swing.*;
import javax.swing.border.TitledBorder;

import utils.*;

/**
 * 
 * @author mladoue
 * @version 0.1, Jun 13, 2003
 */
public class ScenarioFilePanel extends JPanel{

	//Create a file chooser
	private  final JFileChooser fc = new JFileChooser();
	private JButton browse = new JButton("Browse...");
	protected JTextField scenarioFile, resultDirectory;
	
	public ScenarioFilePanel() {

		this.setLayout( new BoxLayout( this, BoxLayout.Y_AXIS));
	
		JPanel sfPanel = new JPanel();
		sfPanel.setLayout( new BoxLayout(sfPanel,BoxLayout.Y_AXIS) );

		
		 JPanel panel11 = new JPanel();
		 panel11.setLayout(new BoxLayout(panel11,BoxLayout.X_AXIS));
	
		 panel11.add( Box.createRigidArea(new Dimension(30,0)) );
		 panel11.add( new JLabel("Scenario file name :") );
		 panel11.add(Box.createRigidArea(new Dimension(20,0)));
		 scenarioFile= new JTextField("",15);
		 scenarioFile.setMaximumSize(new Dimension(scenarioFile.getPreferredSize().width, 
																			scenarioFile.getPreferredSize().height));
		  
		 panel11.add( scenarioFile );
		 panel11.add(Box.createHorizontalGlue());
		 
		 
		 JPanel panel12 = new JPanel();
		 panel12.setLayout(new BoxLayout(panel12,BoxLayout.X_AXIS));
		 
		 panel12.add(Box.createRigidArea(new Dimension(30,0)));
		 panel12.add(new JLabel("Result Directory :"));
		 panel12.add(Box.createRigidArea(new Dimension(20,0)));
		 resultDirectory = new JTextField( System.getProperty("user.dir"), 30);
		resultDirectory.setMaximumSize(new Dimension(resultDirectory.getPreferredSize().width, 
 																				resultDirectory.getPreferredSize().height));
		 panel12.add( resultDirectory);
		 panel12.add(Box.createRigidArea(new Dimension(30,0)));
		 panel12.add( browse );
		 panel12.add(Box.createRigidArea(new Dimension(40 ,0)));
		 panel12.add( MessageManager.createHelpMessageDialogButton("You could specify an existant scenario file!\n The extension of scenario files is \" .scf \" ."));
		 panel12.add(Box.createHorizontalGlue());
		 
		sfPanel.add(panel11);
		sfPanel.add(Box.createRigidArea(new Dimension(0,5)));
		sfPanel.add(panel12);
		sfPanel.add(Box.createRigidArea(new Dimension(0,5)));
		 
		 makeButtons();
		 
		 setBorder(new TitledBorder("Result File & Directory"));
	
	 	this.add(sfPanel);
	}
	
	public void makeButtons() {
		browse.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fc.addChoosableFileFilter( new ScenarioFileFilter());
				int returnVal = fc.showDialog(null, "Choose");
	          	
				if  (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = fc.getSelectedFile();      
				}
			}}
		);
	}

	
	public void setResultDirectory(String directory) { resultDirectory.setText(directory); }
	public String getResultDirectory() { return resultDirectory.getText(); }

	public void setScenarioFileName(String name) { scenarioFile.setText(name); }
	public String getScenarioFileName() { return scenarioFile.getText(); }
	 
	/**
 	* Si pas de nom ou alors "./" on cree un nom : "./modelName_duration"
   	*
 	*/
	public String createScenarioFileName(ClientPanel cp) {
		String ans = "", name = "";
		//Creation d'un nom forme: du nom du model + duree du test
		name = name.concat( cp.getModelTestName() + "_" + cp.getDuration());
		if ( (scenarioFile.getText()).equals(new String("")) || (scenarioFile.getText()).equals(new String("./")) ) {
			ans = ans.concat("./" + name);
			setScenarioFileName(ans); // Mise a jour du nom du scenario nouvellement cree
		}	
		else { ans = scenarioFile.getText(); }
		
		return ans;
	}
	
	public void freezeInfo(boolean b) {
		scenarioFile.setEditable(!b);
		resultDirectory.setEditable(!b);
		browse.setEnabled(!b);
	}

	public void reset() {
		scenarioFile.setText("");
		resultDirectory.setText(System.getProperty("user.dir"));
		browse.setEnabled(true);
	}

}
