package graphics2.panel.experiment;

import java.awt.Dimension;
import javax.swing.*;


/**
 * Used in MachinesPanel to build specific client properties in a GUI
 * 
 * @author mladoue
 * @version 0.1, Jun 13, 2003
 */
public class ClientDescriptionPanel extends DescriptionPanel {
	

	public ClientDescriptionPanel( MachinesPanel mp ) {
		
		super(mp);
		
		d2Panel.setLayout( new BoxLayout( d2Panel, BoxLayout.Y_AXIS) );
		
		JPanel panel1 = new JPanel();
		panel1.setLayout( new BoxLayout( panel1, BoxLayout.X_AXIS) );

		// Cos panel definition
		cosPanel.setLayout( new BoxLayout( cosPanel, BoxLayout.X_AXIS) );
		cosPanel.add(cosL);
		cosPanel.add(Box.createRigidArea( new Dimension(10,0)));
		cosPanel.add(cos);
		cos.setEditable(false);
		
		panel1.add(Box.createRigidArea( new Dimension(20,0)));
		panel1.add(cosC);
		cosC.addItemListener( cbl );
		panel1.add(Box.createRigidArea( new Dimension(10,0)));
		panel1.add(cosPanel);
		panel1.add(Box.createRigidArea( new Dimension(20,0)));
				
			
		d2Panel.add(Box.createRigidArea( new Dimension(20,5)));
		d2Panel.add(panel1);
	
		JPanel scenPanel = new JPanel();	
		scenPanel.setLayout( new BoxLayout( scenPanel, BoxLayout.X_AXIS) );
		scenPanel.add(scenarioL);
		scenPanel.add(Box.createRigidArea( new Dimension(10,0)));
		scenPanel.add(scenarioName);
		d2Panel.add(Box.createRigidArea( new Dimension(20,5)));
		d2Panel.add(scenPanel);
	
		super.dPanel.add(d1Panel);
		super.dPanel.add( Box.createRigidArea( new Dimension(0,5)) );
		super.dPanel.add(d2Panel);
		
		this.add(dPanel);
	}

	public void freezeInfo(boolean b) {
		cos.setEnabled(!b);
		cosC.setEnabled(!b);
		ipaddress.setEnabled(!b);
		accessType.setEnabled(!b);
	}
	
	public void reset() {
		cos.setText("0");
		ipaddress.setText("");
		cos.setEnabled(true);
		cosC.setEnabled(true);
		ipaddress.setEnabled(true);
		accessType.setEnabled(true);
	}
	
	
	
	

}
