package graphics2.panel.experiment;

import java.awt.Dimension;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.tree.DefaultMutableTreeNode;

import utils.MessageManager;


import graphics2.*;
import graphics2.panel.FlowXmlTreePanel;

/**
 * 
 * @author mladoue
 * @version 0.1, Jun 18, 2003
 */
public class ScenariiListPanel extends JPanel {
	
	private GestionTest gt;
	private ExperimentPanel ep;
	public FlowXmlTreePanel fxtpExperiment;
	
	private JLabel portL = new JLabel("Port number: ");
	private JTextField port = new JTextField("5000",10);
	private JButton addScenario = new JButton("Add scenario >> ");
	private JButton removeScenario = new JButton("Remove scenario");
	
	public ScenariiListPanel(ExperimentPanel ep  ) {
		
		this.ep = ep;
		
		this.fxtpExperiment = new FlowXmlTreePanel(ep.getGestionPanel().getClientPanel(),"");
		Object[] childs = ep.getGestionPanel().getClientPanel().modelsListPanel.fxtpClient.getCurrentTreeImage();
		this.fxtpExperiment.setTreeImage(childs);
		//fxtpExperiment.getTree().getSelectionModel().setSelectionMode( TreeSelectionModel.SINGLE_);
		fxtpExperiment.setEnabled(false);
		
		this.setLayout( new BoxLayout( this, BoxLayout.Y_AXIS) );

		JPanel slPanel = new JPanel();
		slPanel.setLayout( new BoxLayout( slPanel,BoxLayout.X_AXIS) );
		
		JPanel panel1 = new JPanel();
		panel1.setLayout( new BoxLayout( panel1,BoxLayout.Y_AXIS) );
		
		JPanel pPanel = new JPanel(); // port Panel
		pPanel.setLayout( new BoxLayout( pPanel, BoxLayout.X_AXIS) );
		
		pPanel.add( Box.createRigidArea( new Dimension(30,0)) );
		pPanel.add( portL );
		pPanel.add( Box.createRigidArea( new Dimension(10,0)) );
		pPanel.add( port );
		pPanel.add( Box.createRigidArea( new Dimension(20,0)) );
		pPanel.add( MessageManager.createHelpMessageDialogButton("Help window...to do"));
		pPanel.add( Box.createRigidArea( new Dimension(30,0)) );
		
		JPanel panel12 = new JPanel();
		panel12.setLayout( new BoxLayout( panel12,BoxLayout.Y_AXIS) );
		
		// Cree l'interface de specification des scenarios
		panel12.add(fxtpExperiment);
		
		panel1.add( Box.createRigidArea( new Dimension(0,5)) );
		panel1.add(pPanel);
		panel1.add( Box.createRigidArea( new Dimension(0,10)) );
		panel1.add(panel12);
		panel1.add( Box.createRigidArea( new Dimension(0,5)) );
		
		JPanel panel2 = new JPanel();
		panel2.setLayout( new BoxLayout( panel2,BoxLayout.Y_AXIS) );
		
		panel2.add(addScenario);
		panel2.add(Box.createRigidArea( new Dimension(0,20) ));
		panel2.add(removeScenario);
		
		slPanel.add(panel1);
		slPanel.add(Box.createRigidArea( new Dimension(5,0) ));
		slPanel.add(panel2);
		
		makeButtons();
		
		this.add(slPanel);
		
		this.setBorder(new TitledBorder("Available scenarii list"));
	}
	
	public void makeButtons() {
		
		addScenario.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String flowD = getCurrentSelectedNode();
				ep.mtp.addFlow(flowD);
			}
		});
		
		removeScenario.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode) ep.mtp.getTree().getLastSelectedPathComponent();
				if( selectedNode.getLevel() == 3  ) {
					ep.mtp.removeCurrentNode();
				}
				else {
					MessageManager.errorMessage("You don't have selected a flow or scenario definition!",true);
					System.err.println("Bad selection");
				}
			}
		});
	}
	
	/**
	 * Returns a String version of scenario or flow description selected
	 * @return
	 * String
	 */
	public String getCurrentSelectedNode() {
		String ans = "";
		DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode) fxtpExperiment.getTree().getLastSelectedPathComponent();
		if( selectedNode != null && selectedNode.getLevel() == 1  ) {
			ans = selectedNode.toString();
			return ans;
		}
		else {
			MessageManager.errorMessage("You don't have selected a flow or scenario definition!",true);
			System.err.println("Bad file selection");
			return null;
		}
	}
	
	public void freezeInfo(boolean b) {
		 addScenario.setEnabled(!b);
    	 removeScenario.setEnabled(!b);
    	 port.setEnabled(!b);
	  }

	 public void reset() {
		addScenario.setEnabled(true);
		removeScenario.setEnabled(true);
		port.setEnabled(true);
		port.setText("5000");
		
		//updateScenariiListe();
	  }
	
}
