/**
 * VideoCodec : Definition des Codecs Video
 * 
 * @author maria ladoue
 * @version 0.1, 04/07/02
 */

package multimedia.codec;

public class VideoCodec extends CodecAV {

    public int framesSecond;   //   images/secondes
    public CompressionType ct; //   MPEG, MJPEG...

    public static int FRAMES = 0;
    public static int COMPRESSION = 1;
    


 // Definition des constructeurs

/**
 * VideoCodec par defaut
 */
    public VideoCodec() {
		name = new String("Video");
		paramNames = new String[2];

		paramNames[FRAMES] = new String("Frames Number");
		paramNames[COMPRESSION] =  new String("Compression");
		framesSecond = 30;
		ct = new CompressionType(new GOP(12,2));
    }

    /**
     * VideoCodec defines the number of image per seconde and the compression type
     * @param framesSecond it's an int
     * @param compressionType it's a String ex: MJPEG,MPEG...
     */
    public VideoCodec( int framesSecond, CompressionType ct) {
		this();
		this.framesSecond = framesSecond;
		this.ct = ct;
		this.name = ct.getName(); 
    }

    /**
     * VideoCodec defines the number of image per seconde and the compression type
     * @param framesSecond it's an int
     * @param compressionType it's a String ex: MJPEG,MPEG...
     * @param codec name
     */

    public VideoCodec( int framesSecond, CompressionType ct, String nameCodec ) {
		this(framesSecond,ct);
		name = nameCodec;
    }


    // Definition de quelques methodes

    public int getFramesNumber() { return framesSecond;   }

    public void setFramesNumber( int frames ) { framesSecond = frames;  }

    public CompressionType getCompression() {	return ct;  }

    public void setCompression( CompressionType ct  ) {	this.ct = ct;    }

    public int getScale(int idx) { return (ct.getGOP()).getLength(); }

    /**
     * Methode: Main pour tester la classe
     */

    public static void main (String[] args) {
	VideoCodec c1 = new VideoCodec(30,new CompressionType(new GOP(12,2)));
	c1.getFramesNumber();
	//System.out.println((c1.getParamsNames())[1]);
	System.out.println(c1.getParamName(0)  + " "  + c1.getParamName(1));
	
    } // fin de la methode main
}
