/**
 * GenericAggregatedModel : definit les caracteristiques communes a tous les modeles aggreges utilises
 *
 * @author maria ladoue
 * @version 0 , 25/09/02 
 */


package multimedia.model;

public abstract class GenericAggregatedModel {

    /**
     * Le nom du modele: (i.e. ON-OFF, MMPP-N...)
     */
    protected String name;

    /**
     * Le nombre de parametres
     */
    protected int paramsCount;


    /**
     * Renvoie et fixe le nom du modele 
     */
    public String getName() { return name; }
    public void setName(String unNom) { name = unNom; }
    
    
     /**
     * Renvoie le nombre de parametres
     */
    public int getParamsCount() { return paramsCount;}
    public void setParamsCount( int nb ) { this.paramsCount = nb;}
  
    

}
