/**
 * GenericContinuousDistribution : Definit les caracteristiques communes a toutes les lois (= distributions)
 *                                 utilisees
 * 
 * @author maria ladoue
 * @version 0.1, 06/08/02 
 */

package statistic.distribution;

import JSci.maths.statistics.NormalDistribution;

public abstract class GenericContinuousDistribution extends GenericDistribution {

    // Definition des principales valeurs statistiques: cdf,pdf..
    protected NormalDistribution normalStandard = new NormalDistribution();
    
    /**
     * Return the value of Inverse Function at x
     * @param x with x>=0 and x<=1
     */
    public abstract double inverseCdf( double x );
 

    /**
     * Returns the value of the normal standard cumulative distribution function at x
     */
    public double normalStandardCdf(double x) {
	return normalStandard.cumulative(x);
    }

}
