/**
 * LRDFunction : Definition de fonctions de la forme exp(-b*sqrt(k))
 *
 * @author maria ladoue
 * @version 0.1, 01/09/02 
 */

package statistic.function;

import java.lang.Math;

public class LRDFunction extends GenericFunction {

	/**
     * Function type:<BR>
     *   f(k) = (k+1)^(-b) where b>0<BR>
     */
 
	public LRDFunction() {
		super();
		name = new String("LRD");
	}


    public LRDFunction(double b) {
		this();
		this.b = b;
    }

    public double function(int k) throws IllegalArgumentException {
	if (k>=0) {
	    return Math.pow(k+1,-b);
	}
	else {
	    throw new IllegalArgumentException("LRDFunction.function : define for k>=0 and k<" + Integer.MAX_VALUE + ", but k="+ k);
	}
    }
    
    public String getEquation() {
    	return new String("f(k) = (k+1)^(-b) where b>0");
    }

  /**
     * Methode: Main pour tester la classe
     */
    
    public static void main (String[] args) {
    	LRDFunction lrd1 = new LRDFunction(0.2);
    	System.out.println(lrd1.function(1000000));
    	System.out.println(lrd1.function(1000001));
    	System.out.println(lrd1.function(1000001)-lrd1.function(1000000));
    	System.out.println(Math.pow(10,-3));
    	
    }

}
