/**
 * Allegro : Classe pour lancer l'application Allegro, mode graphique/texte
 *
 * @author maria ladoue
 * @version 0.2, 06/08/02 
 */

package temp;
import java.io.*;
import java.util.Vector;

import graphics2.*;
import graphics2.listener.*;

public class Allegro {
	

	public static String HOME_DIR = System.getProperty( "user.home");
	public static String DEFAULT_CONFIG = "./default.conf";
	PrintWriterWithEvent outLog;
	int rmiPort = 1099;
		
	//Inner Class
	
/**
 * PrintWriterWithEvent
 *  Attention, il ne faut pas ecrire plusieurs ligne a la fois
 * Le reader est avertie quand un ligne complete est disponible dans la stream et fait un readLine.
 *  Donc s'il y a plusieurs lignes, il n'en lira qu'une seul.
 */

  public class PrintWriterWithEvent extends PrintWriter {

    private boolean autoFlush;
    Vector listeners;

	// Constructors
    public PrintWriterWithEvent(Writer out) {
      this(out, false);
    }

    public PrintWriterWithEvent(Writer out, boolean autoFlush) {
      super(out, autoFlush);
      this.autoFlush = autoFlush;
      listeners = new Vector();
    }

    public PrintWriterWithEvent(OutputStream out) {
      this(out, false);
    }

    public PrintWriterWithEvent(OutputStream out, boolean autoFlush) {
      super(out, autoFlush);
      this.autoFlush = autoFlush;
      listeners = new Vector();
    }

    /// Leve l'evenement newDataInStream et flush le writer
   
    public void flush() {
      super.flush();
      //GestionTest.dispatchEvent( new WriterEvent(this) );
    }

    public void println() {
      super.println();
      if (autoFlush) {
        //GestionTest.dispatchEvent( new WriterEvent(this) );
      }
    }
    
    public void println(boolean x) {
      super.print(x);
      println();
    }

    public void println(char x) {
      super.print(x);
      println();
    }

    public void println(int x) {
      super.print(x);
      println();
    }

    public void println(long x){
      super.print(x);
      println();
    }

    public void println(float x){
      super.print(x);
      println();
    }

    public void println(double x){
      super.print(x);
      println();
    }

    public void println(char x[]){
      super.print(x);
      println();
    }

    public void println(String x){
      super.print(x);
      println();
    }
 
    public void println(Object x){
      super.print(x);
      println();
    }
 
    /**
     * Ajoute un nouveau listener a la liste de listener du WriterEvent
     */
    public void addWriterListener(WriterListener sl) {
      listeners.addElement(sl);
    }
 
    /**
     * Enleve le listener de la liste de listener du StreamEvent
     */
    public void removeWriterListener(WriterListener tl) {
      listeners.removeElement(tl);
    }
  }
	
/**
 * Main method 
 * 
 */
    public static void main(String args[]) {
    	
    	String configFileName;
    	GestionTest gestionTest;
    	
    	 // Usage: Allegro rmiPort [configFile [ -scenario | -statistics | -traffic ] ]
    	 
    	if ( args.length == 0 ) {
	   			new GestionUDP();
		}
 		else {
    		 if ( args.length >=1 ) {	
    		gestionTest = new GestionTest( Integer.parseInt( args[0] ) );
    	}
    	else { gestionTest = new GestionTest(); }
    	
    	if ( args.length >=2 ) {	configFileName = args[1];  	}
    	
    	else { configFileName = "toto"; }//HOME_DIR + File.seperatorChar + DEFAULT_CONFIG; }
    	
   		try {
   			GestionTest.load(configFileName);
   		}
    catch (IOException ioe) { ioe.printStackTrace();	}	
    
    if ( args.length >=3 && args[2].equals("-scenario")) {
        gestionTest.setVisible(false); 
    	gestionTest.menuItemScenario.doClick();
    }
    else if ( args.length >=3 && args[2].equals("-statistics") ) {
    	gestionTest.setVisible(false); 
    	gestionTest.menuItemStatisticFile.doClick();
    }
    else if ( args.length >=3 && args[2].equals("-traffic") ) {
    	gestionTest.setVisible(false); 
    	gestionTest.menuItemTrafficGeneration.doClick();
    }
    else {
    	gestionTest.setSize(1050, 720);
        gestionTest.setVisible(true); 
    	System.out.println("Traffic generator is ready");
    }
 		}  // enf of else of : if ( args.length == 0 ) {
    }  // end of main
}

