/**
 * GestionUDP : Classe qui construit l'interface de l'application.
 *              Permet de lancer soit un client: GestionUDPClient, soit un serveur: GestionUDPServeur.
 *              Intercepte les vnements et les redistribue au client ou au serveur.
 *
 * @author maria ladoue
 * @version 0.2, 06/08/02 
 */



package temp;
import javax.swing.*;


import java.awt.*;
import java.awt.event.*;
import java.io.FileNotFoundException;


public class GestionUDP extends JFrame{

    //Le ContentPane de la JFrame
    protected Container contentPane;
    //Le TextArea concernant l'tat de la ou les connexions
    public JTextArea textAreaEtatConnexion;
    //Le TextArea concernant l'tat de l'application
    public JTextArea textAreaEtatApplication;
    //La barre de progression de l'application
    protected JProgressBar progressBar;
    //Les menus de cette application
    protected JMenu menuDmarrer, menuArrter, menuGestion, menuOptions;
    //Les objets des menus de cette application
    public JMenuItem menuItemServeur, menuItemClient, menuItemCouper,menuItemQuitter, menuItemPingPong, menuItemRafraichirMessagesConnexion, menuItemEnvoiMessages, menuItemScenarioPlayer;

    // Le client
    protected GestionUDPClient gestionUDPClient;
    // Le serveur
    protected GestionUDPServeur gestionUDPServeur;
    //Le type de l'application
    protected int type;
    //Le type client
    protected final static int client = 0;
    //Le type serveur
    protected final static int server = 1;

    
    /**
     * Construction de l'interface.
     */
    
        public GestionUDP() {
       
	    showWindow();
	    afficherMenus();
	    this.addWindowListener(new WindowAdapter() {	
		public void windowClosing(WindowEvent e) {
		    //System.exit(0);
		    dispose();
		}});
	    this.setTitle("GestionUDP");
	    this.setSize(640,480);
	    this.setVisible(true);
	    accsMenuDmarrage();
        }


    protected void showWindow(){
	contentPane=this.getContentPane();
	textAreaEtatApplication=new JTextArea();
	textAreaEtatApplication.setEditable(false);
	JScrollPane jsp1=new JScrollPane(textAreaEtatApplication);
	textAreaEtatConnexion=new JTextArea();
	textAreaEtatConnexion.setEditable(false);
	JScrollPane jsp2=new JScrollPane(textAreaEtatConnexion);
	JPanel panel=new JPanel();
	panel.setLayout(new GridLayout(2,1));
	panel.add(jsp1);
	panel.add(jsp2);
	contentPane.setLayout(new BoxLayout(contentPane,BoxLayout.Y_AXIS));
	progressBar=new JProgressBar();
	contentPane.add(panel);
	contentPane.add(progressBar);
    }

    protected void afficherMenus(){
	JMenuBar menuBar = new JMenuBar();
	this.setJMenuBar(menuBar);
	menuDmarrer = new JMenu("Dmarrer");
	menuBar.add(menuDmarrer);
	menuItemServeur = new JMenuItem("Serveur");
	menuItemServeur.addActionListener(new DemarrerServeurAction(this));
	menuDmarrer.add(menuItemServeur);
	menuItemClient = new JMenuItem("Client");
	menuItemClient.addActionListener(new DemarrerClientAction(this));
	menuDmarrer.add(menuItemClient);
	
	menuArrter = new JMenu("Arrter");
	menuBar.add(menuArrter);
	menuItemCouper = new JMenuItem("Couper connexion");
	menuItemCouper.addActionListener(new ArreterCouperAction());
	menuArrter.add(menuItemCouper);
	menuItemQuitter = new JMenuItem("Quitter application");
	menuItemQuitter.addActionListener(new ArreterQuitterAction());
	menuArrter.add(menuItemQuitter);
	
	menuGestion = new JMenu("Gestion");
	menuBar.add(menuGestion);
	menuItemPingPong = new JMenuItem("Ping pong");
	menuItemPingPong.addActionListener(new GestionPingPongAction());
	menuGestion.add(menuItemPingPong);
	menuItemEnvoiMessages = new JMenuItem("Envoi messages");
	menuItemEnvoiMessages.addActionListener(new GestionEnvoiMessagesAction());
	menuGestion.add(menuItemEnvoiMessages);
	menuItemScenarioPlayer = new JMenuItem("Scenario Player");
	menuItemScenarioPlayer.addActionListener(new GestionScenarioPlayerAction());
	menuGestion.add(menuItemScenarioPlayer);
	
	menuOptions = new JMenu("Options");
	menuBar.add(menuOptions);
	menuItemRafraichirMessagesConnexion = new JMenuItem("Rafrachir messages connexion");
	menuItemRafraichirMessagesConnexion.addActionListener(new OptionsRafraichirAction());
	menuOptions.add(menuItemRafraichirMessagesConnexion);
    }
    
    protected void accsMenuDmarrage(){
	menuDmarrer.setEnabled(true);
	menuArrter.setEnabled(false);
	menuGestion.setEnabled(false);
	menuOptions.setEnabled(false);
		
	menuItemServeur.setEnabled(true);
	menuItemClient.setEnabled(true);
	menuItemCouper.setEnabled(false);
	menuItemQuitter.setEnabled(false);
	menuItemPingPong.setEnabled(false);
	menuItemEnvoiMessages.setEnabled(false);
	menuItemScenarioPlayer.setEnabled(false);
	menuItemRafraichirMessagesConnexion.setEnabled(false);
    }
    
    protected void accsToutMenu(){
	menuDmarrer.setEnabled(true);
	menuArrter.setEnabled(true);
	menuGestion.setEnabled(true);
	menuOptions.setEnabled(true);
	
	menuItemServeur.setEnabled(true);
	menuItemClient.setEnabled(true);
	menuItemCouper.setEnabled(true);
	menuItemQuitter.setEnabled(true);
	menuItemPingPong.setEnabled(true);
	menuItemEnvoiMessages.setEnabled(true);
	menuItemScenarioPlayer.setEnabled(true);
	menuItemRafraichirMessagesConnexion.setEnabled(true);
    }
    
    void accsMenuClient(){
	menuDmarrer.setEnabled(false);
	menuArrter.setEnabled(true);
	menuGestion.setEnabled(false);
	menuOptions.setEnabled(true);
	
	menuItemServeur.setEnabled(false);
	menuItemClient.setEnabled(false);
	menuItemCouper.setEnabled(true);
	menuItemQuitter.setEnabled(false);
	menuItemPingPong.setEnabled(false);
	menuItemEnvoiMessages.setEnabled(false);
	menuItemScenarioPlayer.setEnabled(false);
	menuItemRafraichirMessagesConnexion.setEnabled(true);
    }

    void accsMenuServeur(){
	menuDmarrer.setEnabled(false);
	menuArrter.setEnabled(true);
	menuGestion.setEnabled(true);
	menuOptions.setEnabled(true);
	
	menuItemServeur.setEnabled(false);
	menuItemClient.setEnabled(false);
	menuItemCouper.setEnabled(true);
	menuItemQuitter.setEnabled(false);
	menuItemPingPong.setEnabled(true);
	menuItemEnvoiMessages.setEnabled(true);
	menuItemScenarioPlayer.setEnabled(true);
	menuItemRafraichirMessagesConnexion.setEnabled(true);
    }
    
    void accsMenuQuitter(){
	menuDmarrer.setEnabled(false);
	menuArrter.setEnabled(true);
	menuGestion.setEnabled(false);
	menuOptions.setEnabled(true);
	
	menuItemServeur.setEnabled(false);
	menuItemClient.setEnabled(false);
	menuItemCouper.setEnabled(false);
	menuItemQuitter.setEnabled(true);
	menuItemPingPong.setEnabled(false);
	menuItemEnvoiMessages.setEnabled(false);
	menuItemScenarioPlayer.setEnabled(false);
	menuItemRafraichirMessagesConnexion.setEnabled(true);
    }

   
    /**  
	 protected class MyWindowAdapter extends WindowAdapter implements ActionListener {
	 public void windowClosing(WindowEvent e) {

	 if (type == server) {
	 gestionUDPServeur.fermerConnexions();
	    }
	    else if (type == client) {
		gestionUDPClient.fermerConnexion(); }
	    
	    //System.out.println("Sortie bourrin non implmente. DANGER. DANGER. DANGER. DANGER. DANGER. DANGER.");
	    System.exit(0);
	}
    */
    
    
    public GestionUDPClient getGestionUDPClient() { return gestionUDPClient; }
    
   /**
    * DemarrerServeurAction :
    */
    
    protected class DemarrerServeurAction implements ActionListener {
	//La classe parente
	protected GestionUDP gestionUDP;
	
	/**
	 * @param GestionUDP la classe parente
	 */
	public DemarrerServeurAction(GestionUDP gestionUDP){
	    this.gestionUDP=gestionUDP;
	}
	
	public void actionPerformed(ActionEvent e) {
	    type=server;
	    try {
			gestionUDPServeur = new GestionUDPServeur(gestionUDP,textAreaEtatConnexion,textAreaEtatApplication,progressBar);
		} catch (FileNotFoundException fnfe) {
		}
	}
	
    }

    /**
     * DemarrerClientAction :
     */
    
    protected class DemarrerClientAction implements ActionListener{
        //La classe parente
        protected GestionUDP gestionUDP;
	
	/**
	 * @param GestionUDP la classe parente
	 */
	public DemarrerClientAction(GestionUDP gestionUDP){
	    this.gestionUDP=gestionUDP;
	}
	
	public void actionPerformed(ActionEvent e){
	    type=client;
	    gestionUDPClient = new GestionUDPClient(gestionUDP,textAreaEtatConnexion,textAreaEtatApplication,progressBar);
	   
	}
    }  // fin class DemarrerClientAction
    
    /**
     * ArreterCouperAction
     */   
    protected class ArreterCouperAction implements ActionListener{
	public void actionPerformed(ActionEvent e){
	    if (type==server){
		gestionUDPServeur.fermerConnexions();
	    }
	    else{
		gestionUDPClient.fermerConnexion();
	    }
	}
    }// fin class ArreterCouperAction
    
    protected class ArreterQuitterAction implements ActionListener{
	public void actionPerformed(ActionEvent e){
	    System.exit(0);
                }
    }// fin class ArreterQuitterAction
    
    protected class GestionPingPongAction implements ActionListener{
	public void actionPerformed(ActionEvent e){
	    gestionUDPServeur.gestionPingPong();
	}
    }// fin class GestionPingPongAction
    
    protected class GestionEnvoiMessagesAction implements ActionListener{
	public void actionPerformed(ActionEvent e){
	    gestionUDPServeur.gestionEnvoiMessages();
	}
    }
    
     protected class GestionScenarioPlayerAction implements ActionListener{
	public void actionPerformed(ActionEvent e){
		try {
	    gestionUDPServeur.gestionScenarioPlayer();
		}
		catch(FileNotFoundException fnfe) {
	 	System.out.println(fnfe.toString());
		}
	}
    }
    
    protected class OptionsRafraichirAction implements ActionListener{
	public void actionPerformed(ActionEvent e){
	    if (type==server){
		gestionUDPServeur.rafraichir();
	    }
	    else{
		gestionUDPClient.rafraichir();
	    }
	}
    }
    
    // Methode main pour tester la classe

    public static void main(String args[]) {
	GestionUDP b = new GestionUDP();
    }
} // fin de la classe GestionUDP
