package temp;
import java.io.*;
import java.util.*;

/**
 * Sauvegarde des rsultats du bench envoi de messages sur le disque dans le rpertoire courant.
 * Le tableau des rsultats contient pour chaque message envoy sa date d'arrive.
 */
public class GestionUDPS3S {
        //Tableau contenant les rsultats du bench.
        //Pour chaque message envoy contient sa date d'arrive.
        protected int[] rsultatsBench;
    	protected int longueurMessages;
        protected int tailleBufferReception, tailleBufferEmission;
        protected int tailleBufferRceptionPaquet;
        protected PrintWriter out;
        protected String nomFichier;

        /**
         * Initialise la sauvegarde des rsultats du bench envoi de messages sur le disque.
         * @param benchResults date d'arriv pour chacun des messages envoys
         * @param longueurMessages longueur des messages utiliss pour effectuer le bench
         * @param tailleBufferReception taille du buffer de rception du socket serveur
         * @param tailleBufferEmission taille du buffer d'mission du socket serveur
         * @param tailleBufferRceptionPaquet taille du buffer pour la rception de paquets
         */
        public GestionUDPS3S(int[] rsultatsBench, int longueurMessages, int tailleBufferReception, int tailleBufferEmission, int tailleBufferRceptionPaquet) {

                this.rsultatsBench=rsultatsBench;
                this.longueurMessages=longueurMessages;
                this.tailleBufferReception=tailleBufferReception;
                this.tailleBufferEmission=tailleBufferEmission;
                this.tailleBufferRceptionPaquet=tailleBufferRceptionPaquet;
                sauvegarderRsultats();
        }
 
        private void sauvegarderRsultats(){
                Date date=new Date();
                long time=date.getTime();
                nomFichier="envoi-messages"+ time +".txt";
                try{
                        out=new PrintWriter(new FileWriter(nomFichier));
                }
                catch (IOException e) {
                        System.out.println("BenchUDPS3S:sauvegarderRsultats => "+e.toString());
                }
                out.println("Rsultats du bench envoi de messages\r");
                out.println("-----------------------------------------------------------------------------------\r");
                out.println("Longueur des messages utilise pour effectuer le bench envoi de messages :\t"+longueurMessages+"\r");
                out.println("Nombre de messages envoys lors du bench :\t"+rsultatsBench.length+"\r");
                out.println("Taille du buffer de rception du socket du serveur :\t"+tailleBufferReception+"\r");
                out.println("Taille du buffer d'mission du socket du serveur :\t"+tailleBufferEmission+"\r");
                out.println("Taille du buffer pour la rception de paquets sur le serveur :\t"+tailleBufferRceptionPaquet+"\r");
                out.println("-----------------------------------------------------------------------------------\r");
                out.println("Prcisions :\r");
                out.println("Le protocole de la couche de Transport UDP assure que l'ordre d'arrive des messages et le mme que celui de l'mission.\r");
                out.println("Le temps d'arrive est  considrer par rapport au temps d'origine 0. Les temps sont donns en millisecondes.\r");
                out.println("-----------------------------------------------------------------------------------\r");
                out.println("Temps d'arrive de chacun des messages envoys :\r");
                for (int i=0;i<rsultatsBench.length;i++){
                                out.println(i+"\t"+rsultatsBench[i]+"\r");
                }
                out.close();
        }
 
        /**
         * Renvoie le nom du fichier sous lequel ont t sauvegard les rsultats.
         * @return le nom du fichier
         */
        public String getNomFichier(){
                return nomFichier;
        }
 
        public static void main(String args[]) {
                int[] i=new int[10];
                i[0]=0;i[1]=0;i[2]=0;i[3]=0;i[4]=110;i[5]=110;i[6]=110;i[7]=110;i[8]=110;i[9]=110;
                GestionUDPS3S b=new GestionUDPS3S(i,20,1000,1000,34);
        }
}
