package traffic;

/**
 * SimpleUDPServer: Thread correspondant a un serveur UDP qui pourra etre lance en mode texte via RunUDPServer
 * 						  Ne permet qu'une seule connexion entre un serveur et un client
 * @author mladoue
 * @version 0.1, 06/12/02 
 */

import java.io.*;
import java.net.*;


public class SimpleUDPServer extends Thread {

	 // Port sur lequel le serveur attend les connexions
    public int srcPort;
    
	protected int destPort;
    // socketUDP est le socket d'ecoute du serveur
    public DatagramSocket socketUDP;
    // Taille des buffers d'emission et de recpetion
    // protected int sendBufferSize,receiveBufferSize;
   	// Taille du buffer pour la reception des paquets
   	// protected int receivedPacketBufferSize;
	public InetAddress clientAddress;
	
	public boolean waitConnection = true;
    
    
	/**
	 * Method SimpleUDPServer.
	 * @param srcPort
	 * @throws SocketException
	 */
    public SimpleUDPServer(int srcPort) throws SocketException {
    		this.srcPort = srcPort; // Port sur lequel on va attendre la connexion d'un client
    	   	socketUDP = new DatagramSocket(srcPort);
    	  	 waitConnection = true;
    	   	this.start();
    }
    
     // methode run du thread
  public void run() {
     
      DatagramPacket message;
      byte[] tampon  = new byte[500];  // taille des paquets pour initialiser la communication
     
      while ( true ) {
      	 try {
	      // Attendre un message emis par le client
	      message  = new DatagramPacket(tampon, tampon.length);
	      socketUDP.receive(message);
	      
	       // Visualisation du message recu    
     		String received = new String(message.getData());
      		System.out.println("Received : "+ received + " on port: " + srcPort);
	      
	    
	      // Envoyer la reponse vers le client dont on recupere l'addresse IP et le port
	        String data = "Hello client";
		 	byte[] sendBuf = data.getBytes();
	  
      		
	      clientAddress = message.getAddress();
	      destPort  = message.getPort();
	      message = new DatagramPacket(sendBuf, sendBuf.length, clientAddress, destPort);
	      
	        try { 
	      		socketUDP.send(message);
	      		System.out.println("Send to: " + clientAddress.getHostName() + " on port: " + destPort + ".\n");
	      		 waitConnection = false;  // on a recu un message d'un client et on lui repond => on est + en attente de connexion 
	      	} 
      		catch  (IOException e) {
	  		System.out.println("Emission failed ...");
	  		e.printStackTrace();
	  		return;
      		  }
        	//System.out.println(Thread.currentThread().getName() + " : Send to " + clientAddress.getHostName() + " on port " + destPort);
	       
	   }
	  catch (IOException e) {
	      e.printStackTrace();
	  }
	} // fin du while
    
} // end run
    

public InetAddress getClientAddress() { return clientAddress; }

public int getDestinationPort() { return destPort; }

public DatagramSocket getDatagramSocket() { return socketUDP; }

public boolean getConnectionState() { return waitConnection;	}

}
