package traffic;

/**
 * SocketEcriture : Cette classe permet d'associer un Thread  un socket pour l'criture de datagrammes.
 *                  <br><u><b>ATTENTION</b></u>: les messages "demandefermeclosed13579" et "fermeclosed02468" sont rservs.
 *                  <br>L'intrt de cette classe est d'viter l'appel bloquant aux fonctions d'criture sur les sockets.
 *                  Le Thread stocke dans une file les messages  envoyer et les envoie ds que possible.
 *                  Par de multiples essais, il a t observ que le programme est bloqu pendant une dure
 *                  de 1  7 fois plus courte en envoyant ses messages en passant par le Thread plutt qu'en
 *                  l'envoyant lui-mme avec la fonction d'envoi standard.
 *                  Bien sur cela n'influe pas sur le dbit de UDP qui reste le mme (A VERIFIER).
 *                 <br>Les datagrammes sont numrots de 0  2147483647 pour monitorer.
 *                  Cette numrotation est inclue dans les donnes utiles des datagrammes.
 *                  Les datagrammes numrots de 0  9 sont des datagrammes rservs pour des vrifications internes au package.
 *                  Une fois arriv au datagramme 2147483647, le package bug.
 */


import java.net.*;
import java.io.*;
import java.util.*;

import utils.*;

//PROBLEMES non rgls:
//      appel  la mthode demandeFermetureSocket des deux cots de la connexion simultanment



public class SocketEcriture extends Thread {
    
    //Le socket par lequel on envoit des datagrammes
    protected DatagramSocket socket;
    //La file de messages  envoyer
    protected FileAttenteSynchronisee file;
    //Boolen indiquant si l'utilisateur a demand la fermeture du socket
    protected boolean demandeFermetureSocket;
    //Boolen indiquant que le socket doit tre ferm
    protected boolean fermerSocket;
    //Boolen indiquant si le Thread est termin
    protected boolean termin;
    //File de messages concernant la connexion
    protected FileAttenteSynchronisee messages;
    //Adresse IP de la machine distante
    protected InetAddress adresseConnexion;
    //Port de la machine distante
    protected int portConnexion;
    
    //Numro du datagramme  envoyer
    //protected int noDatagrammeAEnvoyer;
    
    //Numro du datagramme envoye
    protected int noDatagrammeEnvoye=1;
    
    //Vecteur contenant les derniers messages envoys (permet en cas de perte d'un datagramme de l'envoyer  nouveau)
    protected Vector messagesEnvoys;
    //Numro du datagramme du premier message du vecteur messagesEnvoys
    protected int noPremierMessageVecteur;
    
    //Supposition sur le fait que la machine distante a ferm son socket
    protected boolean fermetureReue;
    
    //Boolen indiquant si le destinataire des datagrammes a eu un problme (datagramme perdu ou dsordonn)
   //protected boolean datagrammeProblme;  // a enlever

    /**
     * Cration du buffer de lecture des datagrammes reus par le socket.
     * @param socket DatagramSocket sur lequel recevoir des datagrammes
     * @param messages File de messages concernant la connexion
     * @param adresseConnexion Adresse IP de la machine distante
     * @param portConnexion Port de la machine distante
     */

    public SocketEcriture(DatagramSocket socket, FileAttenteSynchronisee messages, InetAddress adresseConnexion, int portConnexion){
	this.socket=socket;
	this.messages=messages;
	this.adresseConnexion=adresseConnexion;
	this.portConnexion=portConnexion;
	file = new FileAttenteSynchronisee();

	// Les datagrammes numrots de 0  9 sont rservs  la gestion interne du package
	// Le vecteur qui contient les messages envoys commence donc au datagramme numro 10
	//noDatagrammeEnvoye=1;  // on commence le comptage des paquets a 1
	messagesEnvoys = new Vector();
	//noPremierMessageVecteur = 10;
	noPremierMessageVecteur = 2;
	fermerSocket = false;
	demandeFermetureSocket = false;
	termin = false;
	fermetureReue = false;
	this.start();
    }
    
    /**
     * Implantation de la mthode run de la classe Thread.
     * Rception des datagrammes sur le socket.
     */

    public void run() {
	String message="";
	
	int k=0;
	while ((!fermerSocket) && (!demandeFermetureSocket)){
	  	  
		while (!file.vide()) {
			message = file.retirer();
			envoyerMessage(message);
	    }
	    attendre(300000);  // a faire toute les 5 minutes
	    if (file.vide()) {
		envoyerMessageInformation("1 noemission");
		// On ne fait rien juste informer qu'il n'y a pas d'emission en ce moment
	    }
	}
	if (demandeFermetureSocket){
	    envoyerMessage("1 askclosed");
	}
	if (fermerSocket){
	    envoyerMessage("1 closed");
	    attendreFermetureReue();
	    messages.ajouter("Close the connection with: " + adresseConnexion.getCanonicalHostName()+ ", <" + adresseConnexion.getHostAddress() + " , " + portConnexion + ">");
	    socket.close();
	}
	termin=true;
    }
    
    /**
     * Tente de s'assurer que le message de fermeture de la "connexion" a t bien reu.
     * Pour cela, la mthode envoit un datagramme "d'information".
     * Elle fait ensuite une pause d'une dure non ngligeable.
     * Puis, elle vrifie que le SocketLecture distant n'a pas demand la r-mission de datagrammes perdus ou dsordonns.
     * Si ce n'est pas le cas, elle re-boucle.
     */
    // Voir si c'est utile a conserver

    protected void attendreFermetureReue() {
		while (!fermetureReue){
	    System.out.println("SocketEcriture.attendreFermetureReue : attendreFermetureReue");
	    fermetureReue=true;
	    envoyerMessageInformation("1 closetheconnexion");  // a enlever
	    attendre(1000);
	}
    }
    
    /**
     * Envoi un message au SocketLecture distant pour l'informer 
     */
       protected void envoyerMessageInformation(String message) {
       	//System.out.println("Pas d'emission en cours" );
       	//System.out.println("SocketEcriture.envoyerMessageInformation: "  + "Pas d'emission en cours" );
	      //System.out.println("SocketEcriture.envoyerMessageInformation() envoyerMessageInformation: no=1 message=" + noDatagrammeAEnvoyer);
	      //String donnes="1 "+ noDatagrammeAEnvoyer;
	      
	      String data="1 date:" + new Date().toString() +": "+ message;
	 	 if (message == "1 noemission") {
	      	messages.ajouter(new Date().toString() + ": No emission");
	      }	
	      envoyerDatagramme(data);
    }
    // a enlever
    
    /**
     * Rappelons que les donnes d'un datagramme sont constitues du numro du datagramme concatn  un espace puis au message
     * Construit les donnes  envoyer.
     * Envoie ensuite le datagramme.
     * @param message le message  envoyer
     */

    protected synchronized void envoyerMessage(String message) {
    System.out.println("Envoi du message: no= "  + noDatagrammeEnvoye);
    //System.out.println("SocketEcriture.envoyerMessage : no="  + noDatagrammeEnvoye);
	//System.out.println("SocketEcriture.envoyerMessage : envoyerMessage() no=" + noDatagrammeAEnvoyer);
	//pause pour eviter de surcharger la connexion UDP en envoyant plusieurs centaines de datagrammes les uns derrire les autres
	//UDP fait de la perte de datagrammes si on envoie plus de 200 datagrammes les uns derrire les autres en un temps trs court
	//Solution pas vraiment optimale ...
	//attendre(1);
	messagesEnvoys.add(message);
	//String donnes=noDatagrammeAEnvoyer + " " + message;
	//String donnes = noDatagrammeEnvoye + " " + message;
	noDatagrammeEnvoye++; // a enlever
	//noDatagrammeAEnvoyer++;
	//envoyerDatagramme(donnes);
	envoyerDatagramme(message);
    }

    /**
     * Construit le datagramme avec les donnes passes en paramtre et l'envoie.
     * @param donnes les donnes du datagramme
     */

    protected synchronized void envoyerDatagramme(String donnes) {
	try{
	    DatagramPacket packet;
	    byte[] buf = donnes.getBytes();
	    packet = new DatagramPacket(buf,buf.length,adresseConnexion,portConnexion);
	    socket.send(packet);
	}
	catch (IOException e) {
	    System.out.println("SocketEcriture:envoyerDatagramme() => "+e.toString());
	}
    }
    
    /**
     * Re-envoit le datagramme perdu ainsi que tous les datagrammes qui ont suivi.
     * Cette mthode est appele par l'instance SocketLecture associ au DatagramSocket de cette classe.
     * <br><g><u>ATTENTION</u></g>: rserv  un usage interne au package
     * @param numro le numro du datagramme  re-envoyer
     */
    
/**
     synchronized void renvoyerDatagramme(int numro) {
	   fermetureReue=false;
	   datagrammeProblme=true;
	   //Sachant que le SocketLecture distant n'a pas reu le datagramme dont le numro est pass en paramtre
	   //on est certain qu'il a reu tous les messages prcdant, on peut donc les enlever du vecteur
	   //contenant les derniers messages envoys
	   for (int i=0;i<numro-noPremierMessageVecteur;i++){
	   messagesEnvoys.removeElementAt(0);
	   }
	   noPremierMessageVecteur=numro;
	   int tmp=noDatagrammeAEnvoyer;
	   noDatagrammeAEnvoyer=numro;
	   for (int i=numro;i<tmp;i++){
	   String message=(String)(messagesEnvoys.get(i-numro));
	   envoyerMessage(message);
	   }
	   datagrammeProblme=false;
     } // a enlever
    */
    
    /**
     * Demande  la machine distante de re-envoyer le datagramme.
     * Cette mthode est appele par l'instance SocketLecture associ au DatagramSocket de cette classe.
     * Le datagramme correspondant  cette demande a pour numro 0.
     * Le message du datagramme contient le numro du datagramme  renvoyer.
     * <br><g><u>ATTENTION</u></g>: rserv  un usage interne au package
     * @param numro le numro du datagramme  re-envoyer
     */

/**
    void demanderDatagramme(int numro){
	 System.out.println("SocketEcriture.demanderDatagramme : demanderDatagramme: no=0 message="+numro);
	 String donnes="0 "+numro;
	 envoyerDatagramme(donnes);
    } // a enlever
    */
    
    protected synchronized void attendre(){
	try{
	    wait();
	}
	catch (InterruptedException e) {
	    System.out.println("SocketEcriture:attendre() => "+e.toString());
	}
    }
    
    protected synchronized void attendre(int ms){
	try{
	    wait(ms);
	}
	catch (InterruptedException e) {
	    System.out.println("SocketEcriture:attendre(int ms) => "+e.toString());
	}
    }
    
    protected synchronized void rveiller(){
	notify();
    }
    
    /**
     * Ajoute dans la file un message  envoyer.
     * <br><b><u>ATTENTION</u></b>: il faut imprativement examiner si l'envoi est possible avant d'ajouter
     * un message dans la file en appelant la mthode envoiPossible. Si vous ne le faites pas, une exception
     * EnvoiImpossibleException est susceptible d'tre leve.
     * @param message le message sous forme de chane de caractres
     */

    public void messageAEnvoyer(String message){
	if (!this.envoiPossible()) { 
	    	throw new EnvoiImpossibleException("L'envoi de message est impossible: soit une demande de fermeture a t faite, soit le Thread est termin"); }
			file.ajouter(message);
			//rveil de la mthode run()
			rveiller();
    }
    
    /**
     * Renvoit le socket par lequel on envoie des datagrammes
     * @return le socket
     */
    public DatagramSocket getSocket(){
	return socket;
    }
    
    /**
     * Permet de fermer le socket.
     * <br><u><b>ATTENTION</b></u>: fermeture effective du socket une fois que tous les messages de la file sont envoys.
     * <br><g><u>ATTENTION</u></g>: rserv  un usage interne au package
     */
    void fermerSocket(){
	fermerSocket=true;
	//rveil de la mthode run()
	rveiller();
    }
 
    /**
     * Permet d'effectuer une demande de fermeture du socket.
     * <br><u><b>ATTENTION</b></u>: fermeture effective du socket une fois que tous les messages de la file sont envoys.
     */
    public void demandeFermetureSocket(){
		demandeFermetureSocket=true;
		//rveil de la mthode run()
		rveiller();
    }
    
    /**
     * Renvoit un boolen indiquant si l'envoi de message est possible.<br>
     * Indique si le socket est en cours de fermeture ou si il est ferm.
     * <br><u><b>ATTENTION</b></u>: il faut absolument appeler cette mthode avant d'ajouter un message dans la file.
     * @return un boolen
     */
    
    public boolean envoiPossible(){
		return (!demandeFermetureSocket) && (!termin);
    }
    
    /**
     * Mthode permettant de savoir si le Thread est termin.
     * @return un boolen
     */
    public boolean estTermin(){
	return termin;
    }
}
