package utils;


import java.io.*;

/**
 * Implantation d'un filtre de fichier personnel.
 * Accepte les rpertoires.
 * Accepte les fichiers ayant le suffixe et prfixe passs en paramtres.
 */
public class FiltreFichier extends javax.swing.filechooser.FileFilter{
	private String prefixe,suffixe,descriptionFichiers;

	/**
	* Constructeur du filtre.
	* @param prefixe prfixe des fichiers  filtrer
	* @param suffixe suffixe des fichiers  filtrer
	* @param descriptionFichiers la description des fichiers  filtrer
	*/
	public FiltreFichier(String prefixe, String suffixe, String descriptionFichiers){
		this.prefixe=prefixe;
		this.suffixe=suffixe;
		this.descriptionFichiers=descriptionFichiers;
	}

	/**
	 * Implantation.
	 */
	public boolean accept(File f){
		boolean b=true;
		String nom=(f.getName()).toLowerCase();
		if (!f.isDirectory()){
			if ((nom.length()<prefixe.length()) || (nom.length()<suffixe.length())){
				b=false;
			}
			else{
				if (!nom.endsWith(suffixe))
					b=false;
				if (!(nom.substring(0,prefixe.length())).equals(prefixe))
					b=false;
			}
		}
		return b;
	}

	/**
	 * Implantation.
	 */
	public String getDescription(){
		return descriptionFichiers;
	}
}