package utils;

/**
 * @version
 * @author mladoue
 */
 import java.net.*;
import java.util.Vector;

public class LocalUDPPortsScanner {

int firstPort, lastPort;
 

public LocalUDPPortsScanner() {
	firstPort = 1024;
	lastPort = 65535;	
}
 
 public LocalUDPPortsScanner(int firstPort, int lastPort) {
	this.firstPort = firstPort;
	this.lastPort = lastPort;	
}

/**
 * Method scanner.
 */
public void scanner() {

for (int port=firstPort; port<=lastPort;port++)  {
	try {
		DatagramSocket server = new DatagramSocket(port);
		server.close();
	}
	catch (SocketException e) {
	System.out.println("Un serveur est rattache au port: " + port);	
	}	
}
}// end of scanner

public Vector getUsedPort() {
	//Create a vector where we'll stock used port
 	int size = 8,idx=0;
 	Vector usedPort = new Vector(size);
 
for (int port=firstPort; port<=lastPort;port++)  {
	try {
		DatagramSocket server = new DatagramSocket(port);
		server.close();
	}
	catch (SocketException e) {
		usedPort.insertElementAt(new Integer(port), idx);
		idx++;
	}	
}
return usedPort;
}// end of getUsedPort

public int getFreePortNumber() {
return getUsedPort().size();		
}

public boolean isFree(int unPort) {
if ( getUsedPort().contains(new Integer(unPort)) ) {
	return false;
}
else {
return true;	
}
}

// A verifier
public static boolean isSpecificPortFree( int port) {
	try {
		DatagramSocket server = new DatagramSocket(port);
		server.close();
		return true;
	}
	catch (SocketException e) {
		return false;
	}	
	
}

	public static void main(String[] args) {
	LocalUDPPortsScanner scan1 = new LocalUDPPortsScanner();
	System.out.println( scan1.getFreePortNumber());
	System.out.println( scan1.isFree(5000));
	}
}
