package utils;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * Affiche une bote de dialogue paramtrable permettant de demander des informations  l'utilisateur.
 */
public class MyCustonDialog extends JDialog{
	//Liste de String des libells des champs  remplir
	private Vector listeChamps;
	//Liste de String des valeurs par dfaut des champs correspondant  chacun des libells
	private Vector listeValeursParDefaut;
	//Nom de la bote de dialogue
	private String nomBoite;
	//Le container de la JFrame
	private Container container;
	//Liste des JTextField  remplir par l'utilisateur
	private Vector listeJTextField;
	//Les boutons
	private JButton ok,annuler;
	//Boolen indiquant si la fentre a t ferme en appuyant sur ok, annuler ou la croix
	//true pour ok
	//false dans les autres cas
	private boolean etat;

	/**
	 * Cration de la fentre.
	 * @param frame La fentre qui va contenir cette bote de dialogue
	 * @param nomBoite Le nom de la bote de dialogue
	 * @param listeChamps La liste de String des libells de chacun des champs que l'utilisateur doit remplir
	 * @param listeValeursParDefaut La liste de String des valeurs par dfaut pour chacun des champs
	 */
	public MyCustonDialog(JFrame frame, String nomBoite, Vector listeChamps, Vector listeValeursParDefaut){
		super(frame,nomBoite,true);
		this.listeChamps=listeChamps;
		this.listeValeursParDefaut=listeValeursParDefaut;
		this.nomBoite=nomBoite;
		listeJTextField=new Vector();
		etat=false;
		container=this.getContentPane();
		drawWindow();
	}

	private void drawWindow(){
		container.setLayout(new GridLayout(listeChamps.size()+1,2));

		JLabel label;
		JTextField textfield;
		String string;

		for (int i=0;i<listeChamps.size();i++){
			string=(String)(listeChamps.get(i));
			label=new JLabel(string,SwingConstants.CENTER);
			container.add(label);
			string=(String)(listeValeursParDefaut.get(i));
			textfield=new JTextField(string);
			listeJTextField.add(textfield);
			container.add(textfield);
		}

		ActionListener aa=new ActionListener(){
			public void actionPerformed(ActionEvent evt){
				etat=true;
				setVisible(false);
			}
		};
		ok=new JButton("ok");
		ok.addActionListener(aa);
		container.add(ok);

		aa=new ActionListener(){
			public void actionPerformed(ActionEvent evt){
				setVisible(false);
			}
		};
		annuler=new JButton("annuler");
		annuler.addActionListener(aa);
		container.add(annuler);

		this.setSize(340,25*listeChamps.size()+30+20);
		Toolkit tk=Toolkit.getDefaultToolkit();
		Dimension d=tk.getScreenSize();
		int hauteur=d.height;
		int largeur=d.width;
		this.setLocation((largeur-640)/2,(hauteur-(25*listeChamps.size()+30+20))/2);
		this.setVisible(true);
	}

	/**
	 * Renvoit un boolen indiquant comment la fentre a t ferme.
	 * @return un boolen valant true si la fentre a t ferme en appuyant sur ok, false dans les autres cas
	 */
	public boolean getEtat(){ return etat; }

	/**
	 * Renvoit une liste contenant les champs remplis par l'utilisateur.
	 * @return un vecteur de String
	 */
	public Vector getValeursChamps(){
		Vector listeChampsRemplis=new Vector();
		JTextField textField;
		for (int i=0;i<listeJTextField.size();i++){
			textField=(JTextField)(listeJTextField.get(i));
			listeChampsRemplis.add(textField.getText());
		}
		return listeChampsRemplis;
	}

	private static void main(String args[]) {
		Vector v1=new Vector();
		v1.add("Champ 1");
		v1.add("Champ 2");
		v1.add("Champ 3");
		v1.add("Champ 4");
		Vector v2=new Vector();
		v2.add("Valeur par dfaut 1");
		v2.add("Valeur par dfaut 2");
		v2.add("Valeur par dfaut 3");
		v2.add("Valeur par dfaut 4");
		JFrame frame=new JFrame();
		MyCustonDialog f=new MyCustonDialog(frame,"Titre",v1,v2);
		Vector v3=f.getValeursChamps();
		for (int i=0;i<v1.size();i++){
			String string = (String)(v3.get(i));
			System.out.println(string);
		}
	}
}