package utils;

import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.RemoteException;

/**
 * RegistryListor
 */


public class RegistryListor {
	
	String[] remoteObjects;
	
	public RegistryListor(String hostName, int rmiPort) {
		
		String url = "rmi://" + hostName + ":" + rmiPort + "/";
		
		try {
			remoteObjects = Naming.list(url);
		}
		catch (RemoteException re) { System.err.println(re); }
		catch (MalformedURLException mue) { System.err.println(mue); }
	}
	
	public boolean isServiceAvailable(String serviceName) { 
			for ( int i=0 ; i< remoteObjects.length ; i++) {
				if(remoteObjects[i].equals(serviceName)) { return true; }
			}
			return false;
	}
	
	public String[] getRemoteObjectsList() { return remoteObjects; }
	
	public void listRemoteObjects() {
		for ( int i=0 ; i< remoteObjects.length ; i++) {
			System.out.println(remoteObjects[i]);	
		}	
	}

	public static void main(String[] args) {
		
		int port = 1099;
		
		
		if( args.length == 0 ) {
			System.err.println("Usage : java util.RegistryListor <host> [port]");
			return;
		}
		
		String host = args[0];
		
		if (args.length >1 ) {
		try {
			port = Integer.parseInt(args[1]);
			if (port <1024 || port > 65535) { port = 1099; }
		}
		catch (NumberFormatException nfe) { nfe.printStackTrace(); }
		}
		
		new RegistryListor(host,port);
	
	}
}
