package utils;

import java.util.Vector;

/**
 * This takes N scenarii file in enter and log out only one scenario file which is the aggragtion of these N files
 * @author mladoue
 * @version 0.1, Jun 15, 2003
 */


public class ScenarioAggregator {

	protected String resultFileName;
	protected String[] fileNames;
	protected boolean graphic;

	/**
	 * You defines list od scenarii which have to be aggregated
	 * @param fileNames
	 * @param resultFileName
	 * @param graphic
	 * @throws IllegalArgumentException
	 */
	public ScenarioAggregator( String[] fileNames, String resultFileName, boolean graphic ) throws IllegalArgumentException {
		this.graphic = graphic;
		this.fileNames = testFilesExistence(fileNames);
		this.resultFileName = resultFileName;
	}
	
//	public void createAggregatedScenario() {
//		int fileNumber = fileNames.length;
//		
//		for (int i=0;i<fileNames.length;i++) {
//			FileWriter fw = new FileWriter(resultName) ;
//					FileReader fr = new FileReader(fileName);
//		
//					BufferedReader br = new BufferedReader(fr);
//					BufferedWriter bw = new BufferedWriter(fw);
//
//			
//		}
//		
//	}
	
	/**
	 * To test if scenarii exist and if they don't => they are removed from the list
	 * @param fileNames
	 * @return
	 * String[]
	 */
	public String[] testFilesExistence(String[] fileNames) {
		String[] filesN = fileNames;
		String[] ans;
		Vector removedFileList = new Vector();
		// on test qu'ils existent bien => si ca n'est pas le cas on le retire de la liste
		for (int i=0; i< filesN.length; i++) {
			if ( !FileTest.isExistent( filesN[i]) ) {
				MessageManager.informationMessage("The file " + filesN[i] + " could not be find! \n It will be remove from the aggregation",graphic);
				removedFileList.add( new Integer(i++) ); // on ajoute le numero de fichier entre (1 et N) qui n'existe pas au vecteur removedFileList
			}
		}
		if (removedFileList.size() !=0 ) {
			ans = new String[filesN.length-removedFileList.size()];
			for (int j=1; j<= (filesN.length-removedFileList.size()); j++) {
				if ( !removedFileList.contains(new Integer(j) )) { ans[j] = filesN[j]; }
			}
		}
		else { ans = filesN; }
		return ans;
	}


}
