package utils;

/**
 * ScenarioFileFilter 
 * 
 * @author mladoue
 * @version 0.1, 20/01/03 
 */

import java.io.*;


public class ScenarioFileFilter extends javax.swing.filechooser.FileFilter {
	
	private String fullDescription = null;

	
	
/**
  * Return true if this file should be shown in the directory pane, false if it shouldn't.
  * 	Files that begin with "." are ignored.
  * 	=>Accept all directories and all .scf files
  * @param f a File
  * @return boolean
  */
public boolean accept(File f) {
                  if (f.isDirectory()) {
                      return true;
                  }

                  String extension = FileTest.getExtension(f);
                  if (extension != null) {
                      if ( extension.equals(FileTest.scf)) {
                              return true;
                      } 
                      else { return false;}
                  }
                  return false;
 }
              
 	/**
	 * Returns the human readable description of this filter. 
	 */
        
       public String getDescription() { return "Scenario files";  }
    
    
    public void setDescription( String description ) {  }
    
} 

