package utils.myPlotter;

import java.io.*;
import java.util.StringTokenizer;
import ptolemy.plot.*;

/**
 * PlotterMethods
 * @author mladoue
 * @version 0.1, 17/04/03
 */
public class PlotterMethods {


		/**
		 * Method createPointsFromAudioFile
		 * @param simplePlot : the Plot
		 * @param fileName : the file which contains data
		 * @param connected : if points must be connected or not
		 * @param packetSize : 
		 * @throws FileNotFoundException
		 */
		public static void createPointsFromAudioFile( Plot simplePlot, String fileName, boolean connected, int packetSize) throws FileNotFoundException {
			
			FileReader fichierReq = new FileReader(fileName);
			
			StringTokenizer st;
			String line= "";
			BufferedReader br = new BufferedReader(fichierReq);
				try {
						while ( (line = br.readLine()) != null ) {
	  	
						st = new StringTokenizer(line);
						String token1 = st.nextToken();
						String token2 = st.nextToken();
					
						simplePlot.addPoint(0, (Double.parseDouble(token1) + Double.parseDouble(token2)), packetSize, connected);
						}			
					}
					catch (IOException ioe) {}	
		}

		/**
		 * Method createPointsFromVideoFile
		 * 
		 * @param simplePlot
		 * @param fileName
		 * @param connected
		 * @throws FileNotFoundException
		 */
		public static void createPointsFromVideoFile(Plot simplePlot, String fileName, boolean connected) throws FileNotFoundException {
			
			FileReader fichierReq = new FileReader(fileName);
			
			StringTokenizer st;
			String line= "";
			BufferedReader br = new BufferedReader(fichierReq);
			try {
					while ( (line = br.readLine()) != null ) {
	
					st = new StringTokenizer(line);
		
					String token1 = st.nextToken();
					String token2 = st.nextToken();
					// Dans le cas ou on specifie la taille des paquets (video scenario)
					String token3 = st.nextToken();
					simplePlot.addPoint(0, (Double.parseDouble(token1) + Double.parseDouble(token2)), Double.parseDouble(token3), connected);
					}
				}
				catch (IOException ioe) {}	
		}
	
		public static void createPointsFromIntTable(Plot simplePlot, int[] data, int duration, boolean connected) {
			//double slotDuration = (double)duration/(double)data.length;
			for ( int i=0;i< data.length;i++ ) {
				simplePlot.addPoint(0,(double)i, (double)data[i],connected);
			}	
		}
	
		public static void createPointsFromDoubleTable(Plot simplePlot, double[] data, int duration, boolean connected) {
			//double slotDuration = (double)duration/(double)data.length;
			for ( int i=0;i<data.length;i++ ) {
				simplePlot.addPoint(0,(double)i, data[i],connected);
			}
		
		}
	
	
	
	
	
	
}
