package utils.myPlotter;

import java.awt.BorderLayout;
import java.awt.Container;

import utils.TestParameters;
import ptolemy.plot.Plot;

/**
 * TwoGraphPlotter : THis permit to plot 2 graphs in the same windows
 * 
 * @author mladoue
 * @version 0.1, 16/04/03
 */

public class TwoGraphPlotter extends GenericPlotter {

protected Plot downPlot, upPlot;
protected Container contentPane;
protected static int graphNb = 2;


public TwoGraphPlotter() {
	super(graphNb);
	//	Instantiate the two plots.
	 downPlot = new Plot();
	 upPlot = new Plot();
}		
	

public TwoGraphPlotter(int XSize, int YSize, String windowName) {
	
	super(XSize, YSize, windowName, graphNb);
	//	Instantiate the two plots.
	 downPlot = new Plot();
	 upPlot = new Plot();
}


public void plotTwoIntTableData( int[] slots, int[] newSlots,  int testDuration) {
	
	PlotterProperties.setPlotProperties(upPlot, 350, 300, "Data per Slot: Xi", 0,TestParameters.getMaximumIntValue(slots), 0, testDuration,"time (in mn)","Amount of data");
	PlotterProperties.setPlotProperties(downPlot, 350, 300,  "Data per Slot: Yi", 0, TestParameters.getMaximumIntValue(newSlots), 0, testDuration,"time (in mn)","Amount of data");
	
	PlotterProperties.setSpecificPlotProperties( upPlot, true, false, "cross");
	PlotterProperties.setSpecificPlotProperties( downPlot, true, false, "cross");
	
	PlotterMethods.createPointsFromIntTable(upPlot, slots, testDuration, true);
	PlotterMethods.createPointsFromIntTable(downPlot, newSlots, testDuration, true);
	
	contentPane = this.getContentPane();
	contentPane.setLayout(new BorderLayout());
	
	contentPane.add(upPlot,BorderLayout.NORTH);
	contentPane.add(downPlot,BorderLayout.SOUTH);
	
	show();
}

public void plotTwoDoubleTableData(String plotTitle, double[] values1, double[] values2,  int testDuration, String title1, String title2) {
	
	PlotterProperties.setPlotProperties(upPlot, 350, 300, title1, 0,(int)Math.floor(TestParameters.getMaximumDoubleValue(values1)), 0, testDuration,"time","Period duration (in ms)");
	PlotterProperties.setPlotProperties(downPlot, 350, 300,  title2, 0, (int)Math.floor(TestParameters.getMaximumDoubleValue(values2)), 0, testDuration,"time","Period duration (in ms)");
	
	PlotterProperties.setSpecificPlotProperties( upPlot, true, false, "cross");
	PlotterProperties.setSpecificPlotProperties( downPlot, true, false, "cross");
	
	//plotTwoDataPerSlot(values1, values2);
	PlotterMethods.createPointsFromDoubleTable(upPlot, values1, testDuration, true);
	PlotterMethods.createPointsFromDoubleTable(downPlot, values2, testDuration, true);
	
	contentPane = this.getContentPane();
	contentPane.setLayout(new BorderLayout());
	
	contentPane.add(upPlot,BorderLayout.NORTH);
	contentPane.add(downPlot,BorderLayout.SOUTH);
	
	show();
}



public Plot getSpecificPlot(int plotNumber) {
	if (plotNumber==0) { return upPlot; }
	else  { return downPlot; }
}

}
